;LCD.inc
; 4
;
;
;  RB0/INT          * LCD_D4
;  RB1              * LCD_D5
;  RB2              * LCD_D6
;  RB3/PGM          * LCD_D7
;  RB4              * LCD_R/S
;  RB5              * LCD_E

	#define	_E	    PORTB,5

;----------------------------------------------------------------------;
;                 Initialize the LCD                                   ;
;----------------------------------------------------------------------;
Init_LCD
          
        call		Delay_5_ms
        call		Delay_5_ms
        call		Delay_5_ms ; 15    

		movlw		3
		movwf		Count1
		movwf		PORTB
Li
            bsf		_E		;  LCD 3    0x30
		nop
		nop
		nop
		bcf		_E
		call		Delay_5_ms
		decfsz		Count1,f
		goto		Li
		
		movlw		2		; 4-x 
		movwf		PORTB
	      bsf		_E
		nop
		nop
		nop
		bcf		_E
		clrf		PORTB
		call		Delay_200_us

		movlw		28		; 4- , 2 , 57
		call		SendINS
		movlw		0C		;  
		call		SendINS
		movlw		6
		call		SendINS
		return
 
;----------------------------------------------------------------------;
;  ASCII                                                   ;
;----------------------------------------------------------------------;
SendASCII
 
	      movwf		Temp			; Temp=W
	      swapf		Temp, W		; W=swap(W)
		andlw		0x0F		
		iorlw		b'00010000'	; RS=1,  w=(swap(W) & 0x0F) | b'00010000'
		iorwf		PORTB,f
		iorlw		b'11100000' ; 
		andwf		PORTB,f		

		bsf		_E
		nop
		nop
		nop
		bcf		_E
		movf		Temp, W
		andlw		0x0F
		iorlw		b'00010000'	; RS=1
		iorwf		PORTB,f
		iorlw		b'11100000' ; 
		andwf		PORTB,f		

	      bsf		_E
		nop
		nop
		nop
		bcf		_E
		movlw		b'00011111'
		iorwf		PORTB,f		
		call		Delay_200_us
		return
;----------------------------------------------------------------------;
;      			 			                 ;
;----------------------------------------------------------------------;

SendINS                        

;	 
		movwf	Temp
		swapf	Temp, W
		andlw	0x0F	
		iorwf		PORTB,f
		iorlw		b'11100000' ; 
		andwf		PORTB,f		
		bsf		_E
		nop
		nop
		nop
		bcf		_E
		movf	Temp, W
		andlw	0x0F
		iorwf		PORTB,f
		iorlw		b'11100000' ; 
		andwf		PORTB,f		
		bsf		_E
		nop
		nop
		nop
		bcf		_E

		call	Delay_200_us
		return

;----------------------------------------------------------------------;
;    LCD    Line1	;   1-       
;----------------------------------------------------------------------;
Line1
       movlw  0x080                 
       call   SendINS
       movlw  0x00C                  
       call   SendINS
       return

;----------------------------------------------------------------------;
;    LCD    Line2	;   2-                               ;
;----------------------------------------------------------------------;
Line2
       movlw  0x0C0                 
       call   SendINS
       movlw  0x00C                  
       call   SendINS
       return
;----------------------------------------------------------------------;
CLR_LCD
       movlw 0x01 
       call  SendINS    ; LCD
       movlw  0x00C                  
       call   SendINS
       return
;----------------------------------------------------------------------;
CLR_Line
            movlw       .16
            movwf       Count1
            movlw " "
            call  SendASCII
            decfsz     	Count1, F
            goto        $-3
       return
;----------------------------------------------------------------------;
;                        time delay routines                           ;
;----------------------------------------------------------------------;
Delay_5_ms
;delay = 3'996 machine cycles
            movlw       .47
            movwf       Temp1
            movlw       .6
            movwf       Temp2
            decfsz      Temp1, F
            goto        $-1
            decfsz      Temp2, F
            goto        $-3
		return   
Delay_200_us
;delay = 196 machine cycles
            movlw       .65
            movwf       Temp1
            decfsz      Temp1, F
            goto        $-1
		return 
