;	   ESR  
;	 LCF
;                C/ESR meter
;		  / miron63@tut.by
;		V1
;	 	10/11/2010
;======================================================================================
;	    PIC16F873A
;***************************************************************************************
;* *             *   
;***************************************************************************************

; 1    *  MCLR/Vpp         *  
; 2    *  RA0/AN0          *   .
; 3    *  RA1/AN1          *   
; 4    *  RA2/AN2/Vref-    *  . Set coeff./Set "0"
; 5    *  RA3/AN3/Vref+    *
; 6    *  RA4/T0CKI        *  .+/Test
; 7    *  RA5/AN4/SS       *  .-
; 8    *  Vss              * GND
; 9    *  OSC1/CLKIN       *  4 
; 10   *  OSC2/CLKOUT      *  4 
; 11   *  RC0/T1OSO/T1CKI  * 
; 12   *  RC1/T1OSI/CCP2   * 
; 13   *  RC2/CCP1         * 
; 14   *  RC3/SCK/SCL      * 

; 15   *  RC4/SDI/SDA      *  
; 16   *  RC5/SDO          *   (=33)
; 17   *  RC6/TX/CK        *  , I=2mA
; 18   *  RC7/RX/DT        *  , I=10mA
; 19   *  Vss              * +5V
; 20   *  Vdd              * GND
; 21   *  RB0/INT          * LCD_D4
; 22   *  RB1              * LCD_D5
; 23   *  RB2              * LCD_D6
; 24   *  RB3/PGM          * LCD_D7
; 25   *  RB4              * LCD_R/S
; 26   *  RB5              * LCD_E
; 27   *  RB6/PGC          *
; 28   *  RB7/PGD          *

;****************************************************************************************
Kn_Set  		equ 2
Kn_Plus  		equ 4
Kn_Minus  		equ 5
;****************************************************************************************
	 list      p=PIC16F873a
     #include  P16F873a.inc ;	; 4.000 MHz
	__CONFIG _CP_OFF & _BODEN_ON & _XT_OSC  & _WDT_OFF & _PWRTE_ON & _DEBUG_OFF & _CPD_OFF & _LVP_OFF

	CBLOCK 0x20
;************  . *****************************
        REGA0				;lsb
        REGA1
        REGA2
        REGA3				;msb

        REGB0				;lsb
        REGB1
        REGB2
        REGB3				;msb

        REGC0				;lsb
        REGC1
        REGC2
        REGC3				;msb

	DSIGN				;Digit Sign. 0=positive,1=negative
	DIGIT1				;MSD
	DIGIT2
	DIGIT3
	DIGIT4
	DIGIT5				;Decimal (BCD) digits
	DIGIT6
	DIGIT7
	DIGIT8
	DIGIT9
	DIGIT10	

        MTEMP
        MCOUNT
        DCOUNT
;--------------	  ESR --------------------
	W_TEMP		;   
	STATUS_TEMP
	PCLATH_TEMP

	Temp
	Temp1
	Temp2
	Temp3
	Temp4

	Count1
	Count2
	Count3
 	Count4   
	T0
	T1
	T2
	T3
	T4
	T5	
;************
	AX	;  
	A0
	A1
	A2	;  
	A3
	A4
;************
	BCD0	;  
	BCD1
	BCD2
	BCD3
	Flags       ;- 0=1 -Test_R
      Flag_F;- 0- ,1-Cx1000u,2-Cx10u,3-Cx1u,4-Rx100om,5-Rx10om,6-Rx1om,7- R.
      Uadc_min_H
      Uadc_min_L
      Uadc_max_H
      Uadc_max_L
	Lcd_esr_H
	Lcd_esr_L
	EE_Rx1	;.   ESR  ~2 Om.
	EE_Rx2	;.   ESR  ~20 Om.
	EE_Rx3	;.   ESR  ~100 Om.
;  .
	 Cx1_H      ; . ESR+Cx 1 ,  
	 Cx1_L      ; . ESR+Cx 1 ,  
	 Cx2_H	;   ,  
	 Cx2_L 	;   ,  
       Cou_adcL   ; -   ,  	
       Cou_adcH   ; -   ,  
       Granica	; .   Cx

	 EE_Cx1	;.    .
	 EE_Cx2	;.     ~2.
	 EE_Cx3	;.     ~2.
	 StBy_H	;
	 StBy_L	;
	ENDC
;=============================================================================================
	ORG		0x2100   	;  EEPROM
;					; 	 EEPROM

;     :
Cx_1_2		DE	0x7F, 0x00, 0x7F, 0x00	;  2  127- .
Cx_3  		DE	0x7F, 0x00, 0x00, 0x00	;  2  127- .

Rx_000  		DE	0x03, 0x00, 0x00, 0x00	; "0".
Esr_1 		DE	0x7F, 0x00, 0x00, 0x00	;  2 Om   127- .
Esr_10      	DE	0x64, 0x00, 0x00, 0x00	;  20 Om  100- .
Esr_100		DE	0x64, 0x00, 0x00, 0x00	;  100 Om 100- .
;*********************************************************************************************
EE1 		DE	0x00, 0x00, 0x00, 0x00	;
EE2      	DE	0x00, 0x00, 0x00, 0x00	;
EE3		DE	0x00, 0x00, 0x00, 0x00	;
;    Lx---
C_Lx		DE	0x02, 0x8A, 0x00, 0x00 ; 0x24,0x25
;    Lx---*10
L_Lx		DE	0x27, 0x10, 0x00, 0x00 ; 0x28,0x29
;*********************************************************************************************
;     Cx---*10
C_Cx		DE	0x19, 0x64, 0x00, 0x00 ; 0x2C,0x2D

;==============================================================================================
;==============================================================================================
		org 	0x700 ;  256  1-   
Table	addwf	PCL,F
omega		dt	b'00000000'	; 
		dt	b'00001110'
		dt	b'00010001'
		dt	b'00010001'
		dt	b'00010001'
		dt	b'00001010'
		dt	b'00011011'
		dt	b'00000000'
		
mu		dt	b'00000000'
		dt	b'00000000'
		dt	b'00010010'
		dt	b'00010010'
		dt	b'00010010'
		dt	b'00011110'
		dt	b'00010001'
		dt	b'00010000'

dat_max	dt	b'00000000'	; . .
		dt	b'00001110'
		dt	b'00011111'
		dt	b'00011111'
		dt	b'00011111'
		dt	b'00011111'
		dt	b'00011111'
		dt	b'00000000'
		
dat_1 	dt	b'00000000'	; .
		dt	b'00001110'
		dt	b'00010001'
		dt	b'00011111'
		dt	b'00011111'
		dt	b'00011111'
		dt	b'00011111'
		dt	b'00000000'

dat_2 	dt	b'00000000'	; .
		dt	b'00001110'
		dt	b'00010001'
		dt	b'00010001'
		dt	b'00011111'
		dt	b'00011111'
		dt	b'00011111'
		dt	b'00000000'
		
dat_3 	dt	b'00000000'	; .
		dt	b'00001110'
		dt	b'00010001'
		dt	b'00010001'
		dt	b'00010001'
		dt	b'00011111'
		dt	b'00011111'
		dt	b'00000000'

dat_min 	dt	b'00000000'	; .
		dt	b'00001110'
		dt	b'00010001'
		dt	b'00010001'
		dt	b'00010001'
		dt	b'00010001'
		dt	b'00011111'
		dt	b'00000000'

;***********************************************************************
;=======================================================================
;                 
		org 	0x00 
		goto		init
;------------------ Interrupt -----------------------------------------;
		org		0x004
;------------------ --------------------------------;
		movwf   W_TEMP		
		swapf   STATUS,W	      
		clrf	STATUS
		movwf   STATUS_TEMP	
		movf	PCLATH,W
		movwf	PCLATH_TEMP
;----------------------------------------------------------------------; 	      
;  .
;------------------ --------------------------------;		
		movf	PCLATH_TEMP,W
		movwf	PCLATH
		swapf	STATUS_TEMP,W	
		movwf   STATUS		
		swapf   W_TEMP,F        
		swapf   W_TEMP,W        
		bcf        PIR1,0	;clear interrupt flag
		retfie		;  		
;-------------------------------------------------------------------------------;
;-------------------------------------------------------------------------------;
init
;-------------------------------------------------------------------------------;
;       , ,TMR0,TMR1                                      ;
;-------------------------------------------------------------------------------;
            bsf    STATUS,RP0          ;  1
            movlw B'11111111'          ;  PortA  
            movwf  TRISA
            movlw  0x00                ;  PortB  
            movwf  TRISB

            movlw B'00000001'          ;RC0   
            movwf  TRISC

             bcf  OPTION_REG,7         ;   PortB 7

  		; 
		movlw	 b'10000100'	   ; , Vdd, Vss, AN0, AN1, AN3
		movwf	 ADCON1
            bcf    STATUS,RP0          ;  0

            movlw B'11000110'      ;.  . . ESR.
            movwf   PORTC
            clrf Flag_F
            clrf Flags
		clrf	StBy_H
		clrf	StBy_L
;----------------------------------------------------------------------;
			     bsf   PCLATH,3    ; 1
                       call Init_LCD 
 			     bcf   PCLATH,3    ; 0
;----------------------------------------------------------------------;
             call Z_G		  ;  .
;----------------------------------------------------------------------;
          	bsf  PORTB,7		; Power on.
;    
          btfsc PORTA,Kn_Minus	; .-,  , 
		goto $+6
           call TEXT_Service
           call  Pause01s
          	bsf  Flag_F,0     ; .  "SERVICE.inc"
          btfss PORTA,Kn_Minus	; .-,  , 
		goto $-1

          btfsc PORTA,Kn_Plus	; .+,  , ESR
		goto $+6
           call TEXT_Service
           call  Pause01s
          	bsf  Flag_F,7     ; ESR.  "SERVICE.inc"
          btfss PORTA,Kn_Plus	; .+,  , 
		goto $-1
  	
          btfsc PORTA,Kn_Set	; .+,  , I.
		goto $+4
           call TEXT_Service
           call  Pause01s
           call  Test_10mA
  
;-------------------------------------------------------------------------------------;
;  EEPROM     04h      EE_Cx3.
            movlw      0x04           ;     EEPROM 04h
	call LO_EEPR_1
           movwf EE_Cx3			  ;.     ~2
;-------------------------------------------------------------------------------------;
;  EEPROM     00h      EE_Cx2.
            movlw      0x00           ;     EEPROM 00h
	call LO_EEPR_1
           movwf EE_Cx2			  ;.     ~2
;-------------------------------------------------------------------------------------;
;  EEPROM     02h      EE_Cx1.
            movlw      0x02           ;     EEPROM 02h
	call LO_EEPR_1
           movwf EE_Cx1			  ;.    .
;-------------------------------------------------------------------------------------;
;-------------------------------------------------------------------------------------;
;  EEPROM     14h      EE_Rx3.
            movlw      0x14           ;     EEPROM 14h
	call LO_EEPR_1
           movwf EE_Rx3			  ;.   ESR ~20-100 Om.
;-------------------------------------------------------------------------------------;
;  EEPROM     10h      EE_Cx2.
            movlw      0x10           ;     EEPROM 10h
	call LO_EEPR_1
           movwf EE_Rx2			  ;.   ESR ~2-20 Om.
;-------------------------------------------------------------------------------------;
;  EEPROM     0Ch      EE_Cx1.
            movlw      0x0C           ;     EEPROM 0Ch
	call LO_EEPR_1
           movwf EE_Rx1			  ;.   ESR ~0-2 Om.
;-------------------------------------------------------------------------------------;
START
	btfsc   Flag_F,0        ; Flag_F,0=1     -."0".
	goto $+6
	btfsc   Flag_F,7        ; Flag_F,7=1     -."0".
	goto $+4
      btfsc PORTA,Kn_Plus	; .+,  ,."0",  R.
	goto $+3
        bsf  Flags,0       ;- 0=1 -Test_R
	goto $+2
       bcf  Flags,0        ;- 0=0 - Test_R

	btfsc   Flag_F,7        ; Flag_F,7=1   . .
        call  Service_Rx

	btfsc   Flag_F,0        ; Flag_F,0=1   . .
        call  Service_Cx

	btfsc   Flags,0        ; Flags,0=1  ,."0",  R.
        call  Test_R
;-------------------------------------------------------------------------------------;
;  StBy  4.
	 incfsz StBy_L,f	;
	goto $+6
	 incf StBy_H,f	;
	movlw    0x03 	;   StBy.
      subwf    StBy_H,W ;
 	btfsc STATUS,Z
       bcf  PORTB,7		; Power off.
;-------------------------------------------------------------------------------------;
     call  Pause01s
     call  Pause01s
     call  Pause01s
;-------------------------------------------------------------------------------------;
 	btfsc   Flags,0         ; Flags,0=1     -Kn_Set.
	goto $+6
	btfsc   Flag_F,0        ; Flag_F,0=1     -Kn_Set.
	goto $+4
	btfsc   Flag_F,7        ; Flag_F,7=1     -Kn_Set.
	goto $+2
            btfsc  PORTA,Kn_Set	; 
		goto $+3
 		bsf   PCLATH,3      ; 1
       	GOTO VGA
;-------------------------------------------------------------------------------------;
;  2mA- ./10 .
Scan_2mA10
		movlw		b'11010110' ;  
		movwf		PORTC; 
	; .   .
            bsf    STATUS,RP0          ;  1
            movlw B'00100001'          ; RC0,RC1,RC5   
            movwf  TRISC
            bcf    STATUS,RP0          ;  0
     call  Pause800us
		movlw		b'10000110' ;.   1mA, 6=0.
		movwf		PORTC
;;  R+~20uS   Temp,Temp1
     call  ADC_RA0	;;  R+~20uS
		movlw		b'11010110' ;  
		movwf		PORTC		; 

		movf	 Temp1,W
		movwf	 Uadc_max_H
		movf	 Temp,W
		movwf	 Uadc_max_L
;----------------------------------------------------------------------;
;    768(300), .
	movlw    0x03 
      subwf    Uadc_max_H,W ;
 	btfsc STATUS,Z
	 goto   TEXT_Scan
	; .   .
            bsf    STATUS,RP0          ;  1
            movlw B'00000001'          ; RC1,RC3,  
            movwf  TRISC
            bcf    STATUS,RP0          ;  0
     call  Pause01s
       goto   Esr_10mA
;----------------------------------------------------------------------;
TEXT_Scan
       	call  CLRF_REG_MAT_1
		movf	 Uadc_max_H,W
		movwf	 REGA1
		movf	 Uadc_max_L,W
		movwf	 REGA0
	movlw .7	;
      movwf REGB0	;
  call  divide_1		;.    REGA    
	 call bin2dec_1           ;  REGA ---> DIGIT
;----------------------------------------------------------------------;
       call  Line1_1	            ;   1- 
            call CLR_Line_1
       call  Line1_1	            ;   1- 
       movlw " "
       call  SendASCII_1
       movlw "S"
       call  SendASCII_1
       movlw "c"
       call  SendASCII_1
       movf  DIGIT8,0
       addlw "0"
       call  SendASCII_1
       movf  DIGIT9,0
       addlw "0"
       call  SendASCII_1
       movf  DIGIT10,0
       addlw "0"
       call  SendASCII_1
	 movlw .1			; 
	 call  SendASCII_1
	 
       call  Line2_1	            ;   1- 
            call CLR_Line_1
       call  Line2_1	            ;   1- 
       movlw "C"
     call  SendASCII_1
        movlw "x"
       call  SendASCII_1
       movlw "-"
       call  SendASCII_1
      movlw "s"
       call  SendASCII_1
      movlw "c"
       call  SendASCII_1
      movlw "-"
       call  SendASCII_1
      movlw " "
       call  SendASCII_1
       call  Ubat
	goto START
;----------------------------------------------------------------------;
;----------------------------------------------------------------------; 
; Esr. I.-10mA. . - 330.  
Esr_10mA
	clrf	StBy_H
	clrf	StBy_L
		movlw		b'11010110' ;  
		movwf		PORTC		; 
      call  Pause800us
		movlw		b'01000110' ;.   10mA,7=0.
		movwf		PORTC
      call  ADC_RA0	;  R+~20uS.  Temp,Temp1.
		movlw		b'11010110' ;  
		movwf		PORTC		; 
		movf	 Temp1,W
		movwf	 Uadc_min_H
		movf	 Temp,W
		movwf	 Uadc_min_L
      call  Pause800us
;   R+~40uS.
		movlw		b'01000110' ;.   10mA,7=0.
		movwf		PORTC
	  ;delay 
            movlw       .6
            movwf       Temp1
            decfsz      Temp1, F
            goto        $-1
            nop
     call  ADC_RA0	;  R+~40uS.  Temp,Temp1 
		movlw		b'11010110' ;  
		movwf		PORTC		; 
		movf	 Temp1,W
		movwf	 Uadc_max_H
		movf	 Temp,W
		movwf	 Uadc_max_L

;    768(300), Esr_10mA10.
	movlw    0x03 
      subwf    Uadc_max_H,W ;
 	btfsc STATUS,Z
	 goto   Esr_10mA10
;-------
;  
      	call  CLRF_REG_MAT_1
		movf	 Uadc_max_H,W
		movwf	 REGA1
		movf	 Uadc_max_L,W
		movwf	 REGA0

		movf	 Uadc_min_H,W
		movwf	 REGB1
		movf	 Uadc_min_L,W
		movwf	 REGB0
   call  subtract_1	;.    REGA = 0
	movf   REGA3,f   	;  ,  REG_MAT
      btfss   STATUS,Z  
        call  CLRF_REG_MAT_1 
        call  CLR_REGB_1
		movf	 REGA1,W
		movwf	 REGB1
		movf	 REGA0,W
		movwf	 REGB0

		movf	 Uadc_min_H,W
		movwf	 REGA1
		movf	 Uadc_min_L,W
		movwf	 REGA0 

   call  subtract_1	;.    REGA	= 520
	movf   REGA3,f   	;  ,  REG_MAT
      btfss   STATUS,Z  
        call  CLRF_REG_MAT_1
;-------------------------------------------------------------------------------------;
; "0".       
	 call  CLR_REGB_1
;  EEPROM     04h      REGB0.
            movlw      0x08           ;     EEPROM 08h
	call LO_EEPR_1
           movwf REGB0			  ;.   "0".

   call  subtract_1	;.    REGA	= 517
	movf   REGA3,f   	;  ,  REG_MAT
      btfss   STATUS,Z  
        call  CLRF_REG_MAT_1
	movf    REGA1,W	;
	movwf   BCD1	; 
	movf    REGA0,W	;
	movwf   BCD0	; 	= 517
;-------------------------------------------------------------------------------------;
; ESR
        call  CLRF_REG_MAT_1
	movlw 0x03	;873  
      movwf REGB1	;
	movlw 0x69	;
      movwf REGB0	;

	movf	 EE_Rx1,W
      movwf REGA0
	call add_1	;1000
	;
        call  CLR_REGB_1
		movf	 BCD1,W	; 
		movwf	 REGB1
		movf	 BCD0,W	; 
		movwf	 REGB0
	call multiply_1	;	= 517000
        call  CLR_REGB_1 
	movlw 0x01	;341   
      movwf REGB1	;
	movlw 0x55	;
      movwf REGB0	;

  call  divide_1		;.    REGA
		movf	 REGA1,W
		movwf	 Lcd_esr_H
		movf	 REGA0,W
		movwf	 Lcd_esr_L
	
          	bsf  Flag_F,6 
          	bcf  Flag_F,5
           	bcf  Flag_F,4
      btfsc Flags,0 	;Flags-- 0=1 -Test_R,  ,."0",  R.
       	goto START
	goto Cx 
;-------------------------------------------------------------------------  
;-------------------------------------------------------------------------  
; Esr. I.-10mA. . - 33. R= ~2-25 .    
Esr_10mA10

	; .  . .. - 33.
            bsf    STATUS,RP0          ;  1
            movlw B'00100001'          ; RC0,RC1,RC5   
            movwf  TRISC
            bcf    STATUS,RP0          ;  0
     call  Pause005s
		movlw		b'01000110' ;.   10mA,7=0.
		movwf		PORTC
;  R+~20uS 
     call  ADC_RA0	;  R+~20uS.  Temp,Temp1.
		movlw		b'11010110' ;  
		movwf		PORTC		; 
		movf	 Temp1,W
		movwf	 Uadc_min_H
		movf	 Temp,W
		movwf	 Uadc_min_L
     call  Pause800us
;   R+~40uS.
		movlw		b'01000110' ;.   10mA,7=0.
		movwf		PORTC
		;delay = 20 machine cycles
            movlw       .6
            movwf       Temp1
            decfsz      Temp1, F
            goto        $-1
            nop
           ; nop
     call  ADC_RA0	;  R+~40uS.  Temp,Temp1.
		movlw		b'11010110' ;  
		movwf		PORTC		; 
		movf	 Temp1,W
		movwf	 Uadc_max_H
		movf	 Temp,W
		movwf	 Uadc_max_L
	; .  . .. - 330.
            bsf    STATUS,RP0          ;  1
            movlw B'00000001'          ; RC1,RC3,  
            movwf  TRISC
            bcf    STATUS,RP0          ;  0

;    768(300), Esr_2mA10.
	movlw    0x03 
      subwf   Uadc_max_H,W ;
 	btfsc STATUS,Z
	 goto   Esr_2mA10

;  
      	call  CLRF_REG_MAT_1
		movf	 Uadc_max_H,W
		movwf	 REGA1
		movf	 Uadc_max_L,W
		movwf	 REGA0

		movf	 Uadc_min_H,W
		movwf	 REGB1
		movf	 Uadc_min_L,W
		movwf	 REGB0
   call  subtract_1	;.    REGA
	movf   REGA3,f   	;  ,  REG_MAT
      btfss   STATUS,Z  
        call  CLRF_REG_MAT_1

        call  CLR_REGB_1
	movlw .102	
      movwf REGB0	;   100 + .
		call multiply_1	;.  -  *100.
	movf    REGA1,W	;
	movwf   BCD1	; 
	movf    REGA0,W	;
	movwf   BCD0	; 

        call  CLRF_REG_MAT_1
		movf	 Uadc_min_H,W
		movwf	 REGA1
		movf	 Uadc_min_L,W
		movwf	 REGA0

	movf	 EE_Rx2,W	;~100
      movwf REGB0

	call multiply_1 ;.
        call  CLR_REGB_1
		movf	 BCD1,W	; 
		movwf	 REGB1
		movf	 BCD0,W	; 
		movwf	 REGB0
   call  subtract_1	;.  -   *100.
	movf   REGA3,f   	;  ,  REG_MAT
      btfss   STATUS,Z  
        call  CLRF_REG_MAT_1

        call  CLR_REGB_1
	movlw .37	;;   1 - ~35.  
      movwf REGB0	;
  call  divide_1		;  .  -  Rx. 
		movf	 REGA1,W
		movwf	 Lcd_esr_H
		movf	 REGA0,W
		movwf	 Lcd_esr_L
            
          	bcf  Flag_F,6 
          	bsf  Flag_F,5
           	bcf  Flag_F,4
      btfsc Flags,0 	;Flags-- 0=1 -Test_R,  ,."0",  R.
       	goto START
	goto Cx2 
;----------------------------------------------------------------------;
; Esr. I.-2mA. . - 33. R= ~25-80 .
Esr_2mA10
	; .   . . - 33.
            bsf    STATUS,RP0          ;  1
            movlw B'00100001'          ; RC0,RC1,RC5   
            movwf  TRISC
            bcf    STATUS,RP0          ;  0
     call  Pause800us
		movlw		b'10000110' ;.   2mA, 6=0.
		movwf		PORTC
;  R+~20uS 
     call  ADC_RA0	;  R+~20uS.  Temp,Temp1.
		movlw		b'11010110' ;  
		movwf		PORTC		; 
		movf	 Temp1,W
		movwf	 Uadc_min_H
		movf	 Temp,W
		movwf	 Uadc_min_L
     call  Pause800us
;   R+~30uS.
		movlw		b'10000110' ;.   2mA, 6=0.
		movwf		PORTC
		;delay 
            movlw       .2
            movwf       Temp1
            decfsz      Temp1, F
            goto        $-1
            nop
            nop
          ;  nop
;  R+~30uS.
     call  ADC_RA0	;  R+~30uS.  Temp,Temp1.
		movlw		b'11010110' ;  
		movwf		PORTC		; 
		movf	 Temp1,W
		movwf	 Uadc_max_H
		movf	 Temp,W
		movwf	 Uadc_max_L
	; .   . . - 330.
            bsf    STATUS,RP0          ;  1
            movlw B'00000001'          ; RC1,RC3,  
            movwf  TRISC
            bcf    STATUS,RP0          ;  0

;    768(300),  ESR.
	movlw    0x03 
      subwf   Uadc_max_H,W ;
 	btfsc STATUS,Z
		goto Esr_x
;  
      	call  CLRF_REG_MAT_1
		movf	 Uadc_max_H,W
		movwf	 REGA1
		movf	 Uadc_max_L,W
		movwf	 REGA0

		movf	 Uadc_min_H,W
		movwf	 REGB1
		movf	 Uadc_min_L,W
		movwf	 REGB0
   call  subtract_1	;.    REGA
	movf   REGA3,f   	;  ,  REG_MAT
      btfss   STATUS,Z  
        call  CLRF_REG_MAT_1

        call  CLR_REGB_1
	movlw .210	;   ,     Uadc_max-  2."0"
      movwf REGB0	;   100 , 2*100 =200 + .
        call multiply_1	;.  -  *100.
	movf    REGA1,W	;
	movwf   BCD1	; 
	movf    REGA0,W	;
	movwf   BCD0	; 

        call  CLRF_REG_MAT_1
		movf	 Uadc_min_H,W
		movwf	 REGA1
		movf	 Uadc_min_L,W
		movwf	 REGA0
	movf	 EE_Rx3,W	;~100
      movwf REGB0
	call multiply_1 ;.
        call  CLR_REGB_1
		movf	 BCD1,W	; 
		movwf	 REGB1
		movf	 BCD0,W	; 
		movwf	 REGB0
   call  subtract_1	;.  -   *100.
	movf   REGA3,f   	;  ,  REG_MAT
      btfss   STATUS,Z  
        call  CLRF_REG_MAT_1

        call  CLR_REGB_1
	movlw .71	;;   1 - ~70.  
      movwf REGB0	;
        call  divide_1		;  .  -  Rx. 
		movf	 REGA1,W
		movwf	 Lcd_esr_H
		movf	 REGA0,W
		movwf	 Lcd_esr_L

          	bcf  Flag_F,6 
          	bcf  Flag_F,5
           	bsf  Flag_F,4
      btfsc Flags,0 	;Flags-- 0=1 -Test_R,  ,."0",  R.
       	goto START
  	goto Cx3
;----------------------------------------------------------------------;
Esr_x
      call  Line1_1	            ;   1- 
            call CLR_Line_1
       call  Line1_1	            ;   1- 
       movlw " "
       call  SendASCII_1

       movlw "E"
       call  SendASCII_1
       movlw "s"
       call  SendASCII_1
       movlw "r"
       call  SendASCII_1
       movlw "-"
       call  SendASCII_1
       movlw "-"
       call  SendASCII_1
       movlw "-"
       call  SendASCII_1
	goto Cx3		;   .
;----------------------------------------------------------------------;
;----------------------------------------------------------------------;
;  .
;----------------------------------------------------------------------;
;Cx   ~2  ~15..
Cx2 
	call  CLRF_REG_MAT_1
		movf	 Uadc_max_H,W
		movwf	 REGA1
		movf	 Uadc_max_L,W
		movwf	 REGA0
		movf	 Uadc_min_H,W
		movwf	 REGB1
		movf	 Uadc_min_L,W
		movwf	 REGB0
   call  subtract_1	;.    REGA
	movf    REGA1,W	;
	movwf   BCD1	; 
	movf    REGA0,W	;
	movwf   BCD0	; 

        call  CLR_REGB_1
; ,   ,     .
	movlw .50	;   "50"(~15),     .
	movwf REGB0	;
   call  subtract_1	;.    REGA
	movf   REGA3,f   
      btfss   STATUS,Z 
        goto   Cx
   
; .     ~2.
	call  CLRF_REG_MAT_1
	;   .
	movlw 0x04	; 
      movwf REGA1	;
	movlw 0x60	;
      movwf REGA0	;

	movf  EE_Cx2,W 		  ;.     ~2,  
      movwf      REGB0          ;  04h-EEPROM   W   REGB0.
	call add_1
	;----	 
        call  CLR_REGB_1
	movlw .54	;
	movwf REGB0	;
	call multiply_1	; ~70 000
        call  CLR_REGB_1
		movf	 BCD1,W	; 
		movwf	 REGB1
		movf	 BCD0,W	; 
		movwf	 REGB0
   call  divide_1		;.    REGA
         	bcf  Flag_F,1 
     bsf  Flag_F,2 ;- 0- , 1-Cx1000u, 2-Cx10u, 3-Cx1u, .
           	bcf  Flag_F,3

       goto   Lcd_Cx

;----------------------------------------------------------------------;
;Cx   ~2..
Cx3 
   	call  CLRF_REG_MAT_1
		movf	 Uadc_max_H,W
		movwf	 REGA1
		movf	 Uadc_max_L,W
		movwf	 REGA0
		movf	 Uadc_min_H,W
		movwf	 REGB1
		movf	 Uadc_min_L,W
		movwf	 REGB0
   call  subtract_1	;.    REGA
	movf    REGA1,W	;
	movwf   BCD1	; 
	movf    REGA0,W	;
	movwf   BCD0	; 

        call  CLR_REGB_1
; ,   ,   .
	movlw .5	;   "5",    .
	movwf REGB0	;
   call  subtract_1	;.    REGA
	movf   REGA3,f   
      btfss   STATUS,Z  
        goto   TEXT_Cx_no
; .     ~2.
	call  CLRF_REG_MAT_1
	;   .
	movlw .50	; 
	movwf REGA0	;
	movf  EE_Cx3,W 			 ;.     ~2,  
           movwf      REGB0          ;  04h   W   REGB0.
	;----	
	call multiply_1	; ~7 000
        call  CLR_REGB_1
		movf	 BCD1,W	; 
		movwf	 REGB1
		movf	 BCD0,W	; 
		movwf	 REGB0
   call  divide_1		;.    REGA 
	         	bcf  Flag_F,1 
     			bcf  Flag_F,2 
           	bsf  Flag_F,3 ;- 0- , 1-Cx1000u, 2-Cx10u, 3-Cx1u.
       goto   Lcd_Cx

;======================================================================;
;----------------------------------------------------------------------;
;  .
Cx
          ;  movlw  0x2F	; .  (Cx~120 000)
  		movlw  0x14		; .  (Cx~60 000)
        	movwf  Granica 	; .	
            movlw  .1
        	movwf  Cou_adcL		;  . ESR+Cx 1 .
        	clrf  Cou_adcH
	; .   . . - 33.
            bsf    STATUS,RP0          ;  1
            movlw B'00100001'          ; RC0,RC1,RC5   
            movwf  TRISC
            bcf    STATUS,RP0          ;  0
;    Cx
       call  Pause800us
;----------------------------------------------------------------------;
;  . ESR+Cx 1 .
		movlw		b'01000110' ;.   10mA,7=0.
		movwf		PORTC
     call  ADC_RA0 ;         Temp,Temp1.
		movf	 Temp1,W
		movwf	 Cx1_H
		movf	 Temp,W
		movwf	 Cx1_L
		nop
           goto   CI     ;6,7Cikl
;----------------------------------------------------------------------;
;          0x200(512). 
CIKL  
;delay = 21 machine cycles
      	nop
		nop
		nop
		nop
		nop
		nop
CI_1 		nop
CI		nop
		nop
		nop
		nop
		nop
		nop
 		nop
CI_2		nop
		nop
		nop
		nop
		nop
      	nop
		nop
     call  ADC_RA0 ;         Temp,Temp1.
;    512(200),  .
	movlw    0x02
      subwf   Temp1,W 	;   ,  
 	btfsc STATUS,C  ;3,4
      goto  CI_3      ;
		;  .
           incfsz Cou_adcL, F  ;5  -   ,  
            goto  CIKL         ;6,7Cikl
            incf Cou_adcH, F   ;1  -   ,  
;    ,     
		movf	 Temp1,W 	; 2    ,  
       	subwf Cx1_H,W	; 3
		btfss STATUS,Z	; 4
            goto  CI_1 		; 5,6
		movf	Cx1_L,W		; 6
       	subwf Temp,W	;   ,  
		movwf	 Temp2	; 8
		movlw    0x02	; 9
	      subwf Temp2,W	; 10
		btfss STATUS,C	; 11,12
              goto  TEXT_Cx_no
           decfsz Granica, F	 ;0x14  .  (Cx~60 000), .
            goto  CI_2         ;13,14 Cikl
              goto  TEXT_Cx_no
CI_3
		movlw		b'11010110' ;  
		movwf		PORTC		; 
		movf	 Temp1,W	;   ,  
		movwf	 Cx2_H
		movf	 Temp,W	;   ,  
		movwf	 Cx2_L

	; .   . . - 330.
            bsf    STATUS,RP0          ;  1
            movlw B'00000001'          ; RC1,RC3,  
            movwf  TRISC
            bcf    STATUS,RP0          ;  0
;----------------------------------------------------------------------;
;-----  .
Cx_mat
	;   .		
	call  CLRF_REG_MAT_1
	movlw .10
	movwf REGA0	;
	    movf  EE_Cx1,W 	      ;.    . 
          movwf      REGB0          ;  02h   W   REGB0.
   call  multiply_1	;.    REGA 
	  call  CLR_REGB_1
	movlw 0x10	;
	movwf REGB1	;
	movlw 0xDE	; 
	movwf REGB0	;
	call add_1	; ~5 588
	;----	
	  call  CLR_REGB_1
		movf	 Cou_adcL,W	;  -  .
		movwf	 REGB0
		movf	 Cou_adcH,W	;  -  .
		movwf	 REGB1
    call  multiply_1	;.    REGA 
	movf    REGA3,W	;
	movwf   BCD3	; 
	movf    REGA2,W	;
	movwf   BCD2	; 
	movf    REGA1,W	;
	movwf   BCD1	; 
	movf    REGA0,W	;
	movwf   BCD0	; 

	call  CLRF_REG_MAT_1
		movf	 Cx2_H,W	;,    
		movwf	 REGA1
		movf	 Cx2_L,W	;,    
		movwf	 REGA0

		movf	 Cx1_H,W	;,    
		movwf	 REGB1
		movf	 Cx1_L,W	;,    
		movwf	 REGB0
    call  subtract_1	;.    REGA,
; ,   ,   .
	movf    REGA1,W	; 
	movwf   Temp1	;
	movf    REGA0,W	;
	movwf   Temp	; 
        call  CLR_REGB_1
	movlw .5	;   "5",    .
	movwf REGB0	;
   call  subtract_1	;.    REGA
	movf   REGA3,f   
      btfss   STATUS,Z  
        goto   TEXT_Cx_no

	call  CLRF_REG_MAT_1
	movf    Temp1,W	;
	movwf   REGB1	;
	movf    Temp,W	;
	movwf   REGB0	;

	movf    BCD3,W	; 
	movwf   REGA3	;
	movf    BCD2,W	; 
	movwf   REGA2	;
	movf    BCD1,W	; 
	movwf   REGA1	;
	movf    BCD0,W	; 
	movwf   REGA0	;

    call  divide_1	;.    REGA
	     bsf  Flag_F,1 ;- 0- , 1-Cx1000u, 2-Cx10u, 3-Cx1u.
     			bcf  Flag_F,2 
           		bcf  Flag_F,3 
          goto  Lcd_Cx
;----------------------------------------------------------------------;
;----------------------------------------------------------------------;
TEXT_Cx_no
		movlw		b'11010110' ;  
		movwf		PORTC		; 
	; .  . .
            bsf    STATUS,RP0          ;  1
            movlw B'00000001'          ; RC1,RC3,  
            movwf  TRISC
            bcf    STATUS,RP0          ;  0

       call  Line2_1	            ;   2- 
            call CLR_Line_1
       call  Line2_1	            ;   2- 
       movlw "C"
       call  SendASCII_1
        movlw "x"
       call  SendASCII_1
       movlw "-"
        call  SendASCII_1
      movlw "n"
        call  SendASCII_1
      movlw "o"
       call  SendASCII_1
      btfsc Flags,6 	;Flags-- 6=1 - R   1.5 
                call Mat_R
     goto   Lcd_esr 
Lcd_Cx
       call bin2dec_1           ;  REGA ---> DIGIT
;---     .  Cx -- ---
       call  Line2_1	            ;   1- 
            call CLR_Line_1
       call  Line2_1	            ;   1- 
 
       movlw  " "		
       call  SendASCII_1

       btfss  Flag_F,1 ;- 0- , 1-Cx1000u, 2-Cx10u, 3-Cx1u.
          goto  DIGIT_Cmin ;    Cx --.--

;   ------------------------------------------ 

	movlw    0x01	   ; 
        subwf    DIGIT6,0  ;
 	btfsc STATUS,C
       goto   C5       ;   xx.xxx uF

	movlw    0x01	   ; 
        subwf    DIGIT7,0  ;
 	btfsc STATUS,C
       goto   C4       ;   x.xxx uF

	movlw    0x01	   ; 
        subwf    DIGIT8,0  ;
 	btfsc STATUS,C
       goto   C3       ;   xxx uF
       goto   C2       ;   xx uF

C5       movf  DIGIT6,0
       addlw "0"
       call  SendASCII_1

C4       movf  DIGIT7,0
       addlw "0"
       call  SendASCII_1
 	 movlw  " "	
       call  SendASCII_1

C3      movf  DIGIT8,0
       addlw "0"
       call  SendASCII_1

	movf   DIGIT6 ,f   	;   10 000,     .
      btfss   STATUS,Z       
           goto  Cx6
C2       movf  DIGIT9,0
       addlw "0"
       call  SendASCII_1

	movf   DIGIT7 ,f   	;   1000,    .
      btfss   STATUS,Z       
           goto  $+7
       movf  DIGIT10,0
       addlw "0"
       call  SendASCII_1
          goto  $+5
Cx6
       movlw  "0"	
       call  SendASCII_1
       movlw  "0"	
       call  SendASCII_1
         goto   Txt_uF 

DIGIT_Cmin	;    Cx---.--

	movf   DIGIT7,f   ;   
      btfsc   STATUS,Z       
           goto  $+4
       movf  DIGIT7,0
       addlw "0"
       call  SendASCII_1
    
	 movf  DIGIT8,0
       addlw "0"
       call  SendASCII_1
          movlw "."
       call  SendASCII_1
       movf  DIGIT9,0
       addlw "0"
       call  SendASCII_1

	movf   DIGIT7 ,f   ;   10,    .
      btfss   STATUS,Z       
           goto  $+4
       movf  DIGIT10,0
       addlw "0"
       call  SendASCII_1
 
Txt_uF   movlw .2	; 
        call  SendASCII_1
           movlw "F"
       call  SendASCII_1
;---------------------------------------------------------------------------------
;   ESR.
Lcd_esr
      	call  CLRF_REG_MAT_1
		movf	 Lcd_esr_H,W
		movwf	 REGA1
		movf	 Lcd_esr_L,W
		movwf	 REGA0
       call bin2dec_1           ;  REGA ---> DIGIT
	       call  Line1_1	            ;   1- 
            call CLR_Line_1
       call  Line1_1	            ;   1- 
       movlw " "
       call  SendASCII_1
  
	btfsc   Flag_F,6;- 0- , 1-Cx10u, 4-Rx100om, 5-Rx10om, 6-Rx1om, 7- R.
        goto $+4

	movf   DIGIT7,f   ;   
      btfsc   STATUS,Z       
           goto  $+4
      movf  DIGIT7,0
       addlw "0"
       call  SendASCII_1
 
	btfss   Flag_F,6; Esr-6-Rx1om.
       goto  $+3
       movlw ","
       call  SendASCII_1

       movf  DIGIT8,0
       addlw "0"
       call  SendASCII_1
	btfss   Flag_F,5; Esr-10om,5-Rx10om.
       goto  $+3
       movlw ","
       call  SendASCII_1

       movf  DIGIT9,0
       addlw "0"
       call  SendASCII_1
	btfss   Flag_F,4; Esr-100om, 4-Rx100om.
       goto  $+3
       movlw ","
       call  SendASCII_1

	btfss   Flag_F,5; Esr-10om.    Rx --.--
       goto  $+4
	movf   DIGIT7,f   
      btfss   STATUS,Z       
           goto  $+4
       movf  DIGIT10,0
       addlw "0"
       call  SendASCII_1

	 movlw .1			; 
	 call  SendASCII_1

	       goto   START 
;----------------------------------------------------------------------;
;==========================================================;
;----------------------------------------------------------------------;
;    ..
ADC_RA0	
		movlw		b'10000001'   ;Fosc/32,  0,   .
		movwf		ADCON0
            movlw       .5
        	movwf       Temp1
            decfsz      Temp1, F
            goto        $-1
		bsf		ADCON0,2	  ; - 
		btfsc		ADCON0,2
		goto		$-1		  ;   
		movf	 ADRESH,W
		movwf	 Temp1
            bsf    STATUS,RP0          ;  1
		movf	 ADRESL,W
            bcf    STATUS,RP0          ;  0
		movwf	 Temp
		return
;----------------------------------------------------------------------;
;----------------------------------------------------------------------;
;  Ubat.
Ubat
	   	call  CLRF_REG_MAT_1
		movlw		b'10001001'   ;Fosc/32,  1,   .
		movwf		ADCON0
            movlw       .5
        	movwf       Temp1
            decfsz      Temp1, F
            goto        $-1
		bsf		ADCON0,2	  ; - 
		btfsc		ADCON0,2
		goto		$-1		  ;   
		movf	 ADRESH,W
		movwf	 BCD1
            bsf    STATUS,RP0          ;  1
		movf	 ADRESL,W
            bcf    STATUS,RP0          ;  0
		movwf	 BCD0

		movf	 BCD1,W
		movwf	 REGA1
		movf	 BCD0,W
		movwf	 REGA0
       movlw  0x0C7                 
       call   SendINS_1
;    512(200), Bat max.
	movlw    0x02 
      subwf    REGA1,W ;
 	btfss STATUS,Z
	 goto   $+4
       movlw .3 		; Bat max
       call  SendASCII_1
	 goto   Ubat_end

        call  CLRF_REG_MAT_1
		movf	 BCD1,W
		movwf	 REGA1
		movf	 BCD0,W
		movwf	 REGA0
	movlw 0x01	;483  
      movwf REGB1	;
	movlw 0xE3	;
      movwf REGB0	;
   call  subtract_1	;.    REGA = 0
	movf   REGA3,f   	;  ,  Bat max-1.
      btfss   STATUS,Z  
   	 goto   $+4
       movlw .4 		; Bat max-1
       call  SendASCII_1
	 goto   Ubat_end

        call  CLRF_REG_MAT_1
		movf	 BCD1,W
		movwf	 REGA1
		movf	 BCD0,W
		movwf	 REGA0
	movlw 0x01	;455  
      movwf REGB1	;
	movlw 0xC7	;
      movwf REGB0	;
   call  subtract_1	;.    REGA = 0
	movf   REGA3,f   	;  ,  Bat max-2.
      btfss   STATUS,Z 
   	 goto   $+4
       movlw .5 		; Bat max-2
       call  SendASCII_1
	 goto   Ubat_end

        call  CLRF_REG_MAT_1
		movf	 BCD1,W
		movwf	 REGA1
		movf	 BCD0,W
		movwf	 REGA0
	movlw 0x01	;427  
      movwf REGB1	;
	movlw 0xAB	;
      movwf REGB0	;
   call  subtract_1	;.    REGA = 0
	movf   REGA3,f   	;  ,  REG_MAT
      btfss   STATUS,Z 
   	 goto   $+4
       movlw .6 		; Bat max-3
       call  SendASCII_1
	 goto   Ubat_end

        movlw .7		; Bat max-4
       call  SendASCII_1
Ubat_end
		return
;----------------------------------------------------------------------;
Mat_R
;     .
         call  CLRF_REG_MAT_1
		movf	 Uadc_min_H,W
		movwf	 REGA1
		movf	 Uadc_min_L,W
		movwf	 REGA0 
  
;-------------------------------------------------------------------------------------;
; "0".       
;  EEPROM     04h      REGB0.
            movlw      0x08           ;     EEPROM 08h
	call LO_EEPR_1
           movwf REGB0			  ;.   "0".

   call  subtract_1	;.    REGA	= 517
	movf   REGA3,f   	;  ,  REG_MAT
      btfss   STATUS,Z  
        call  CLRF_REG_MAT_1
	movf    REGA1,W	;
	movwf   BCD1	; 
	movf    REGA0,W	;
	movwf   BCD0	; 	= 517
;-------------------------------------------------------------------------------------;
; ESR
        call  CLRF_REG_MAT_1
	movlw 0x03	;873  
      movwf REGB1	;
	movlw 0x69	;
      movwf REGB0	;

	movf	 EE_Rx1,W
      movwf REGA0
	call add_1	;1000
	;
        call  CLR_REGB_1
		movf	 BCD1,W	; 
		movwf	 REGB1
		movf	 BCD0,W	; 
		movwf	 REGB0
	call multiply_1	;	= 517000
        call  CLR_REGB_1 
	movlw 0x01	;341   
      movwf REGB1	;
	movlw 0x55	;
      movwf REGB0	;

  call  divide_1		;.    REGA
		movf	 REGA1,W
		movwf	 Lcd_esr_H
		movf	 REGA0,W
		movwf	 Lcd_esr_L
			return

;----------------------------------------------------------------------;
TEXT_Service
       call  Line1_1	            ;   1- 
       movlw " "
       call  SendASCII_1
       movlw "S"
       call  SendASCII_1
        movlw "e"
       call  SendASCII_1
       movlw "r"
        call  SendASCII_1
      movlw "v"
        call  SendASCII_1
      movlw "i"
       call  SendASCII_1
      movlw "c"
        call  SendASCII_1
      movlw "e"
       call  SendASCII_1
		return
;----------------------------------------------------------------------;
;delay = 766 machine cycles
Pause800us   movlw       .255
            movwf       Temp1
            decfsz      Temp1, F
            goto        $-1
		return
;----------------------------------------------------------------------;
;delay = 49'996 machine cycles
Pause005s    movlw       .237
            movwf       Temp1
            movlw       .65
            movwf       Temp2
            decfsz      Temp1, F
            goto        $-1
            decfsz      Temp2, F
            goto        $-3
  		return
;----------------------------------------------------------------------;
;delay = 99'996 machine cycles
Pause01s    movlw       .220
            movwf       Temp1
            movlw       .130
            movwf       Temp2
            decfsz      Temp1, F
            goto        $-1
            decfsz      Temp2, F
            goto        $-3
            nop
		return
;----------------------------------------------------------------------;
;delay = 999'996 machine cycles
Pause1s     movlw       .172
            movwf       Temp1
            movlw       .19
            movwf       Temp2
            movlw       .6
            movwf       Temp3
            decfsz      Temp1, F
            goto        $-1
            decfsz      Temp2, F
            goto        $-3
            decfsz      Temp3, F
            goto        $-5
            nop
		return
;---------------------- Load CGRAM LCD ---------------------
;       .
Z_G
			movlw		b'01001000' ; AC in CGRAM=8
		bsf   PCLATH,3    ; 1
			call		SendINS
		bcf   PCLATH,3    ; 0
			movlw 		HIGH Table
			movwf 		PCLATH
			movlw		.56			;16   8 
			movwf		Count1
			movlw		LOW  omega-1
			movwf		Count2		;  

	       	call		Table			;   
		bsf   PCLATH,3    ; 1
			call		SendASCII
		bcf   PCLATH,3    ; 0
			incf		Count2,F
			movf		Count2,W
			decfsz	Count1,F
			goto		$-7
		return
;  0       LCD,  EEPROM, ..
;------------------------------------------------------------------------------------;
SendASCII_1
		bsf   PCLATH,3      ; 1
	call  SendASCII
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
SendINS_1
		bsf   PCLATH,3      ; 1
	call  SendINS
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
Line1_1
 		bsf   PCLATH,3      ; 1      
	call  Line1
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
Line2_1
 		bsf   PCLATH,3      ; 1      
	call  Line2
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
CLR_Line_1
 		bsf   PCLATH,3      ; 1      
	 call CLR_Line
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
LO_EEPR_1
 		bsf   PCLATH,3      ; 1
	call LO_EEPR
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
SAV_EEPR_1
 		bsf   PCLATH,3      ; 1
	call SAV_EEPR
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
CLRF_REG_MAT_1
 		bsf   PCLATH,3      ; 1      
	call  CLRF_REG_MAT
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
CLR_REGB_1
 		bsf   PCLATH,3      ; 1      
	call  CLR_REGB
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
subtract_1
 		bsf   PCLATH,3      ; 1      
	call  subtract
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
divide_1
 		bsf   PCLATH,3      ; 1      
	 call divide
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
bin2dec_1
 		bsf   PCLATH,3      ; 1
	 call bin2dec
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
multiply_1
 		bsf   PCLATH,3      ; 1
	call multiply
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
add_1
		bsf   PCLATH,3      ; 1
	call add
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;

;************************************************************************
;  
	INCLUDE "SERVICE.inc"
;************************************************************************
;***********          1        **********************************
;************************************************************************
  org 	0x800 ;  1
;*******************************************************************************
;**********       VGA       *****************************
;*******************************************************************************
;	Ceramic resonator 4MHz, Tcycle=1mkS
;	640*480 /60hz  31,2KHz/1mks=32   
;***************640*480 /60hz *******************************************

VGA
          	bsf  PORTB,7		; Power on.
	clrf	StBy_H
	clrf	StBy_L

	#define Horz	PORTB,3
;**********************************************************************;          
;            Initialize the ports and timer1                           ;
;----------------------------------------------------------------------;
            bsf    STATUS,RP0
		movlw		b'00000111'; DDDDDDDD
		movwf		ADCON1
            bcf    STATUS,RP0
		CLRF   PORTC
            bsf    PORTC,3	;  ESR
            bsf    PORTC,2	;  F
            bsf    PORTC,1	;  LC
;-------------------------------------------------------------------------;
;   LCD
       call  Line1	            ;   1- 
       call  CLR_Line
       call  Line2	            ;   2- 
       call  CLR_Line
       call  Line1	            ;   1- 
       movlw  " "		
       call  SendASCII
       movlw  "V"		
       call  SendASCII
       movlw  "G"		
       call  SendASCII
       movlw  "A"		
       call  SendASCII
       movlw  ">"		
       call  SendASCII
       call  Line2	            ;   2- 
       movlw  "6"		
       call  SendASCII
       movlw  "4"		
       call  SendASCII
       movlw  "0"		
       call  SendASCII
       movlw  "*"		
       call  SendASCII
       movlw  "4"		
       call  SendASCII
       movlw  "8"		
       call  SendASCII
       movlw  "0"		
       call  SendASCII
 	      call Pause05sek
	
;===================================================
		movlw b'10000000'                   
START_vga	movwf PORTB       	        ;vsync + hsync,   1
             call  Pause4
		bsf	Horz                      ;End of sync      6
      	movlw d'29'	      	        ;7
		movwf	Count1     	  	        ;8
  		movlw D'239'                    ;9
		movwf	Count2 	              ;10
		movwf	Count3		        ;11
;-------------------------------------------;
;  StBy  4.
	 incfsz StBy_L,f	;12,13
	goto st1		;13,14
	 incf StBy_H,f	;14
	movlw    .50 	;   StBy.15
      subwf    StBy_H,W ;16
 	btfsc STATUS,Z	;17,18
        call  PWR_OFF	; Power off.
	      call Pause7  ;
            call Pause4
	      nop
		goto $+4  	 ;31,32
st1         call Pause4  ;15
	      call Pause7  ;
	      call Pause7  ;32      1ctroka

;==================================================================================;
Loop1		bcf	Horz                      ; Horz sync ,     1
             call  Pause4
		bsf	Horz                      ;End of sync      6
	      call Pause21		        ;7,27
	      nop			              ;28
	      nop			              ;29
		decfsz Count1,f                 ;30,31 
            goto Loop1        	        ;31,32
	    	movlw b'11000000'			  ;32      31ctroka
;===================================================
		movwf PORTB  		        ;end of vsync + hsync, 1
             call  Pause4	
		bsf	Horz                      ; end of hsync         6
	      call Pause21		        ;7,27   
  		movlw D'10'                     ;28
		movwf	Count4     		        ;29
	      nop			              ;30
	      nop			              ;31
	      nop			              ;32	 
;===================================================
Loop2      	bcf	Horz                      ; Horz sync , 1
             call  Pause4
		bsf	Horz                      ;End of sync      6
	      movlw b'11001111'	              ; 7,End of sync 
		movwf PORTB		              ;8   
	      nop	
		movlw b'11001011'	              ;10 		    
		movwf PORTB		              ; Jaune	    
	      nop	
		movlw b'11001110'		        ;	          
		movwf PORTB		              ; Cyan	    
	      nop	
		movlw b'11001010'		        ;16	          
		movwf PORTB                     ; Vert        
	      nop	
		movlw b'11001101'	              ;		    
		movwf PORTB      	              ; Magenta     
	      nop	
		movlw b'11001001'	              ;22		    
		movwf PORTB		              ; Rouge       
	      nop	
		movlw b'11001100'		        ;25		    
		movwf PORTB		              ; Bleu        
	      nop	                 		  ;
	      movlw b'11001000'		        ; 
		movwf PORTB		              ;29

		decfsz Count2,f                 ;30    239cikl       
            goto Loop2        		  ;31,32
		nop	      			  ;32
 
Loop3      	bcf	Horz                      ; Horz sync , 1
             call  Pause4
		bsf	Horz                      ;End of sync      6
	      movlw b'11001111'	              ; 7	    
		movwf PORTB		              ;8          
	      nop	
		movlw b'11001011'	              ;10 		    
		movwf PORTB		              ; Jaune	    
	      nop	
		movlw b'11001110'		        ;	          
		movwf PORTB		              ; Cyan	    
	      nop	
		movlw b'11001010'		        ;16	          
		movwf PORTB                     ; Vert        
	      nop	
		movlw b'11001101'	              ;		    
		movwf PORTB      	              ; Magenta     
	      nop	
		movlw b'11001001'	              ;22		    
		movwf PORTB		              ; Rouge       
	      nop	
		movlw b'11001100'		        ;25		    
		movwf PORTB		              ; Bleu        
	      nop	                 		  ;
	      movlw b'11001000'		        ; 
		movwf PORTB		              ;29
		decfsz Count3,f                 ;239cikl       
            goto Loop3        		  ;31,32
		nop
;===================================================
Loop4       bcf	Horz                  ; Horz sync ,    1
             call  Pause4
		bsf	Horz                  ;End of sync      6
	      call Pause21		    ;7,27   
         	btfss PORTA,Kn_Minus	    ; .-, 28,29
		goto 	VGA1		          ;29
		decfsz Count4,f   	    ;30       10cikl
            goto Loop4                  ;31,32
		nop	      	          ;32
;************************************************
            bcf	Horz                  ; Horz sync ,     1
 		nop			          ;2
		nop			          ;3
		nop	
		bsf	Horz                  ;End of sync      5
	      call Pause21		    ;6,26 

            btfss  PORTA,Kn_Set	; , 27,28
       	GOTO LMETR
		nop	
		movlw b'10000000'                 ;30  
		goto START_vga                    ;31,32
;********************************************************************************
;********************************************************************************
VGA1
;	Ceramic resonator 4MHz, Tcycle=1mkS
;	1280*1024 /60hz  63,9KHz/1mks=16   
	
;***************1280*1024 /60hz **********
          	bsf  PORTB,7		; Power on.
	clrf	StBy_H
	clrf	StBy_L
;-------------------------------------------------------------------------;
;   LCD
       call  Line1	            ;   1- 
       call  CLR_Line
       call  Line2	            ;   2- 
       call  CLR_Line
       call  Line1	            ;   1- 
       movlw  " "		
       call  SendASCII
       movlw  "V"		
       call  SendASCII
       movlw  "G"		
       call  SendASCII
       movlw  "A"		
       call  SendASCII
       movlw  "1"		
       call  SendASCII
       movlw  "2"		
       call  SendASCII
       movlw  "8"		
       call  SendASCII
       movlw  "0"		
       call  SendASCII
       call  Line2	            ;   2- 
       movlw  "*"		
       call  SendASCII
       movlw  "1"		
       call  SendASCII
       movlw  "0"		
       call  SendASCII
       movlw  "2"		
       call  SendASCII
       movlw  "4"		
       call  SendASCII
	      call Pause05sek
;===================================================
		movlw b'10000000'                   
START_vga1	movwf PORTB       	        ;vsync + hsync,   1
       	movlw d'70'	      	        ;2
		movwf	Count1     	  	        ;3
		bsf	Horz                      ;End of sync      4

;-------------------------------------------;
;  StBy  4.
	 incfsz StBy_L,f	;5,6
	goto st2		;6,7------------
	 incf StBy_H,f	;7
	movlw    .50 	;   StBy.8
      subwf    StBy_H,W ;9
 	btfsc STATUS,Z	;10,11
        call  PWR_OFF	; Power off.
      	goto $+4  	 ;12,13

st2         call Pause4  ;11
            nop			           
	      nop
  		movlw D'240'                    ;14
		movwf	Count2 	              ;15
		movwf	Count3		        ;16      1ctroka
;===================================================
Loop1_1	bcf	Horz                      ; Horz sync ,     1
            nop			              ;2
	      nop
		bsf	Horz                      ;End of sync      4
	      call Pause7 		        ;5,11
            nop			              ;12
	      nop
		decfsz Count1,f                 ;14,15
            goto Loop1_1        	        ;
	    	movlw b'11000000'			  ;16    31ctroka
;===================================================
		movwf PORTB  		        ;end of vsync + hsync, 1
            nop			              ;2
	      nop	
		bsf	Horz                      ; end of hsync         4
	      call Pause7 		        ;5,11  
  		movlw D'10'                     ;12
		movwf	Count4     		        ;13
	      nop			              ;14
   	      movlw b'11001000'		        ;  15
;===================================================
Loop2_1 	movwf PORTB	   			  ;16
		bcf	Horz                      ; Horz sync , 1
            nop			              ;2
	  	movlw b'11001010'		        ;3 
		bsf	Horz                      ;End of sync      4
    		movwf PORTB                     ; Vert   5
  		call  Pause4
	      nop
	      nop
     	      movlw b'11001000'		        ;  12
		decfsz Count2,f                 ;13,14    239cikl       
            goto Loop2_1        		  ;14,15
		nop	      			  ;15
 
Loop3_1  	movwf PORTB	   			  ;16  
	  	bcf	Horz                      ; Horz sync , 1
  		nop
		movlw b'11001001'		       
		bsf	Horz                      ;End of sync      4
		movwf PORTB                     ; Vert        
  		call  Pause4
 		movlw D'240'                    ;
		movwf	Count2
     	      movlw b'11001000'		        ;  12
		decfsz Count3,f                 ;cikl       
            goto Loop3_1        		  ;
		nop	      			  ;15
 
Loop5_1     movwf PORTB	   			  ;16 
	  	bcf	Horz                      ; Horz sync , 1
  		nop                   
		movlw b'11001100'		     
		bsf	Horz                      ;End of sync      4
		movwf PORTB                     ; Vert        
  		call  Pause4
  		movlw D'240'                    
		movwf	Count3 	              
     	      movlw b'11001000'		        ;  12
		decfsz Count2,f                 ;cikl       
            goto Loop5_1        		  ;
		nop	      			  ;15
Loop6_1     movwf PORTB	   			  ;16
	   	bcf	Horz                      ; Horz sync , 1
		nop
		movlw b'11001001'	
		bsf	Horz                      ;End of sync      4
		movwf PORTB                     ; Vert        
  		call  Pause4
	      nop
	      nop
     	      movlw b'11001000'		        ;  12
		decfsz Count3,f                 ;cikl       
            goto Loop6_1        		  ;
		nop	      			  ;15
		movwf PORTB	   			  ;16
;===================================================
Loop4_1     bcf	Horz                  ; Horz sync ,    1
            nop			          ;2
	      nop
		bsf	Horz                  ;End of sync     4
	      call Pause7    
         	btfss PORTA,Kn_Minus	    ; .-, 12,13
		goto 	VGA		          
		decfsz Count4,f   	    ;14,15      
            goto Loop4_1                  
		nop	      	          ;16
;************************************************
            bcf	Horz                  ; Horz sync ,     1
 		nop			          ;2
		nop			          ;3
		bsf	Horz                  ;End of sync      4
	      call Pause7 

            btfss  PORTA,Kn_Set	    ;   ,12,13
       	GOTO LMETR
		movlw b'10000000'                  ;14  
		goto START_vga1                    ;15,16

;************************************
;===================================================
PWR_OFF
;   LCD
       call  Line1	            ;   1- 
       call  CLR_Line
       call  Line2	            ;   2- 
       call  CLR_Line
       call  Line1	            ;   1- 
       movlw  " "		
       call  SendASCII
       movlw  "P"		
       call  SendASCII
       movlw  "W"		
       call  SendASCII
       movlw  "R"		
       call  SendASCII
       movlw  "_"	
       call  SendASCII

	 movlw  "o"		
       call  SendASCII
       movlw  "f"		
       call  SendASCII
       movlw  "f"		
       call  SendASCII
       bcf  PORTB,7		; Power off.
	goto $-1
         return
;-------------------------------------------------------------------------;
;delay = 4 machine cycles
Pause4
         return
;delay = 7 machine cycles
Pause7
		nop			          
		nop			          
		nop			          
         return
;delay = 17 machine cycles
Pause21      movlw       .5
            movwf       Temp1
            decfsz      Temp1, F
            goto        $-1
            nop
         return


;************************************************************************
;***********          LMETR      **********************************
;************************************************************************

LMETR
	clrf	StBy_H
	clrf	StBy_L
          	bsf  PORTB,7		; Power on.

	 call Line1    ; 
	 call CLR_Line
       call Line2 
	 call CLR_Line
       call Line1
       movlw " "
       call  SendASCII
       movlw "L"
       call  SendASCII
       call Text_Metr
       call Pause05sek 

		 clrf Flag_F		
;************************************************************************          
;            Initialize the ports and timer1                           ;
;----------------------------------------------------------------------;
            bsf    STATUS,RP0
		movlw		b'00000111'; DDDDDDDD
		movwf		ADCON1
            movlw B'00000001'          ;RC0,inputs  other outputs
            movwf  TRISC
            bcf    STATUS,RP0
		bcf	INTCON,7	; 
            movlw  B'00000110'
            movwf  T1CON
            bcf    T1CON,0      ;0  TMR1ON:  TMR1    1=.

;-------------------------------------------------------------------------;
            bsf    PORTC,3	;  ESR
            bsf    PORTC,2	;  F
            bcf    PORTC,1	;  LC
;-------------------------------------------------------------------------;
Restart
;  StBy  4.
	 incfsz StBy_L,f	
	goto $+6		
	 incf StBy_H,f	
	movlw    .3 	;   StBy.
      subwf    StBy_H,W 
 	btfsc STATUS,Z	
        call  PWR_OFF	; Power off.

;----------  F_metr----------------------------------------------
		btfsc		PORTA,Kn_Set  
   	    goto $+2
           	goto F_metr 
;-------------------------------------------------------------------------;
;----------  c_metr----------------------------------------------
		btfss		PORTA,3  
   	    goto $+2
           	goto _metr 
;-------------------------------------------------------------------------;
;   LC .   LC                                           ;
;    \REGA0\ REGA1\ F=F/100
;-------------------------------------------------------------------------;
    call LC_F
;****   1300   ********************************
	movlw    0x01	 ; 
        subwf    REGA1,0 ;
 	btfsc STATUS,C
       goto   A_F        ;

	movlw    0x83	 ; d'01'
        subwf    REGA0,0 ;
 	btfsc STATUS,C
       goto   A_F        ;   1500  
	 call Line1    ; 
	 call CLR_Line
       call Line2 
	 call CLR_Line
        call  Line1	;   1- 	
	    call  Text_Lx

            goto    Restart
A_F
	clrf	StBy_H
	clrf	StBy_L
;--------    --------------------------;

	movf    REGA1,0	;
	movwf   REGB1	;
	movf    REGA0,0	;
	movwf   REGB0	;

    call  multiply	;.    REGA 
;---------   1000()------------------------------------;
	clrf	REGB3
	clrf	REGB2
  	movlw   0x03  	;   
	movwf   REGB1	
  	movlw   0xE8  	;   
	movwf   REGB0	;
    call  divide	;.    REGA

;  F^2/1000
	movf    REGA1,0	;
	movwf   T1	;
	movf    REGA0,0	;
	movwf   T0	;

;--------------------------------------------------------------

	        btfsc  PORTA,Kn_Plus
	      goto   K_C
	    call   Pause05sek 
		btfsc  PORTA,Kn_Plus
	      goto   K_C
	    call   Cal_L
K_C          
;------------------------------------------------------------------------- 
;************   F mkH = 25330/C/F^2************************
;------- 253 300 000-------------------------------------

	movlw 0x0F	;   
	movwf REGA3	;

	movlw 0x19	;  
	movwf REGA2	;

	movlw 0x0D	;  
	movwf REGA1	;

	movlw 0x20	;  
	movwf REGA0	;

;--------------   C xxx pF--------------------------------
;===============================================================================================
;  EEPROM     24h      REGB1.  pF
;-----------------------------------------------------------------------------------------------
	clrf	REGB3
	clrf	REGB2
	   movlw      0x24
	call LO_EEPR
	   movwf      REGB1

;  EEPROM     25h      REGB0.

            movlw      0x25           ;     EEPROM 25h
	call LO_EEPR
            movwf      REGB0          ;  24h   W   EEAdr.
;-----------------------------------------------------------------
	call  divide	;.    REGA 

;   1000.   
	clrf	REGB3
	clrf	REGB2

	movlw 0x03	;
	movwf REGB1	;
	movlw 0xE8	;  1000
	movwf REGB0	;

    call  multiply	;.    REGA 

;-------  F^2 ----------------------------
	clrf	REGB3
	clrf	REGB2
        movf  T1,0   ;  
     	movwf REGB1	;

 	movf  T0,0  	;  
	movwf REGB0	;

    call  divide	;.    REGA 

;    Cal_L,  0
;  EEPROM  2-  
      movf  REGA1,0     ;   
     	movwf T3	;
 	movf  REGA0,0  	;  
	movwf T2	;
;--------------------------------------------------------------------------------------
            btfss  T5,0 ;   ר  \C\L\
	      goto   $+7
;   100.   
	clrf	REGB3
	clrf	REGB2
	clrf	REGB1
	movlw 0x64	;  100
	movwf REGB0	;
    call  multiply	;.    REGA 
;---------------------------------------------------------------------------------------
;  10000  , 0
      clrf	REGB3
	clrf	REGB2
;  EEPROM     28h      REGB1.
	   movlw      0x28
	call LO_EEPR
	   movwf      REGB1

;  EEPROM     29h      REGB0.

            movlw      0x29           ;     EEPROM 25h
	call LO_EEPR
            movwf      REGB0          ;  29h   W   REGB0.
;----------- --------------------------------------------
       call Line1    ; 
	 call CLR_Line
       call Line2 
	 call CLR_Line
            call  Line1 	;   1- 
       	movlw " "
       	call  SendASCII 
;	     	movlw "L"
;      	call  SendASCII 
;     	movlw "x"
;       	call  SendASCII 
;       	movlw " "
;       	call  SendASCII 
;--------------------------------------------------------------------
    call  subtract	;.    REGA  0
;******************   ******************************** 

;-----------   ----------------------------------------
 	btfss DSIGN,0
      goto   $+3
       	movlw "-"
       	call  SendASCII
;--------------------------------------------------------------------       
 
       call bin2dec     ;  REGA ---> DIGIT


;  ------------------------------------------ 
 
	movlw    0x01	   ; 
        subwf    DIGIT1,0  ;
 	btfsc STATUS,C
       goto   Lx_H         ;   Lx- xx.xx H

	movlw    0x01	   ; 
        subwf    DIGIT2,0  ;
 	btfsc STATUS,C
       goto   Lx_H         ;   Lx- x.xx H

	movlw    0x01	   ; 
        subwf    DIGIT3,0 ;
 	btfsc STATUS,C
       goto  Lx_mH        ;   Lx- xxx.xx mH

	movlw    0x01	  ; 
        subwf    DIGIT4,0 ;
 	btfsc STATUS,C
       goto  Lx_mH1         ;   Lx- xx.xx mH

	movlw    0x01	  ; 
        subwf    DIGIT5,0 ;
 	btfsc STATUS,C
       goto   Lx_mH2      ;    Lx- x.xx mH

	movlw    0x01	  ; 
        subwf    DIGIT6,0 ;
 	btfsc STATUS,C
       goto   Lx_ukH      ;   Lx- xxx.xx ukH

	movlw    0x01	  ; 
        subwf    DIGIT7,0 ;
 	btfsc STATUS,C
       goto   Lx_ukH1     ;   Lx- xx.xx ukH 

       goto   Lx_ukH2     ;   Lx- x.xx ukH 
;-----------------------------------------------------------------------;
;           Lx- xxx.xx ukH                                ;
;-----------------------------------------------------------------------; 
Lx_ukH

	movf  DIGIT6,0
       addlw "0"
       call  SendASCII   
Lx_ukH1       movf  DIGIT7,0
       addlw "0"
       call  SendASCII 
Lx_ukH2       movf  DIGIT8,0
       addlw "0"
       call  SendASCII
        movlw ","
       call  SendASCII 
       movf  DIGIT9,0
       addlw "0"
       call  SendASCII 
      movf  DIGIT10,0
       addlw "0"
       call  SendASCII 
        movlw " "
       call  SendASCII
            call  Line2 	;   2- 
       movlw "u"
       call  SendASCII
       movlw "k"
       call  SendASCII
       movlw "H"
       call  SendASCII
       goto    Restart
;-----------------------------------------------------------------------;
;             Lx- xxxx.x mH                               ;
;-----------------------------------------------------------------------; 
Lx_mH
     
       movf  DIGIT3,0
       addlw "0"
       call  SendASCII 
Lx_mH1       movf  DIGIT4,0
       addlw "0"
       call  SendASCII
Lx_mH2       movf  DIGIT5,0
       addlw "0"
       call  SendASCII
       movlw "."
       call  SendASCII  
       movf  DIGIT6,0
       addlw "0"
       call  SendASCII
       movf  DIGIT7,0
       addlw "0"
       call  SendASCII
       movlw " "
       call  SendASCII
            call  Line2 	;   2- 
       movlw "m"
       call  SendASCII
       movlw "H"
       call  SendASCII
        goto    Restart
;-----------------------------------------------------------------------;
;-----------------------------------------------------------------------;
;               Lx- xx.xx H                               ;
;-----------------------------------------------------------------------; 
Lx_H
       
        movf  DIGIT1,0
       addlw "0"
       call  SendASCII
       movf  DIGIT2,0
       addlw "0"
       call  SendASCII
        movlw ","
       call  SendASCII 
       movf  DIGIT3,0
       addlw "0"
       call  SendASCII 
       movf  DIGIT4,0
       addlw "0"
       call  SendASCII
        movf  DIGIT5,0
          movlw " "
       call  SendASCII
            call  Line2 	;   2- 
       movlw "H"
       call  SendASCII
       movlw "e"
       call  SendASCII 
       movlw "n"
       call  SendASCII
        movlw " "
       call  SendASCII	  
       goto    Restart

;************************************************************************
;***********  *************************************
;************************************************************************
_metr
	clrf	StBy_H
	clrf	StBy_L
          	bsf  PORTB,7		; Power on.
       call Line1    ; 
	 call CLR_Line
       call Line2 
	 call CLR_Line

       call Line1
       movlw " "
       call  SendASCII
       movlw "C"
       call  SendASCII
       call Text_Metr 
        call Pause05sek 

;-------------------------------------------------------------------------;
	 clrf Flag_F
;-------------------------------------------------------------------------;
_Restart
;  StBy  4.
	 incfsz StBy_L,f	
	goto $+6		
	 incf StBy_H,f	
	movlw    .3 	;   StBy.
      subwf    StBy_H,W 
 	btfsc STATUS,Z	
        call  PWR_OFF	; Power off.

;----------  LMETR----------------------------------------------
		btfsc		PORTA,3  
   	    goto $+2
           	goto LMETR 
;-------------------------------------------------------------------------;
;----------  F_metr----------------------------------------------
		btfsc		PORTA,Kn_Set  
   	    goto $+2
           	goto F_metr 
;-------------------------------------------------------------------------;
;   LC .   LC                                           ;
;    \REGA0\ REGA1\ F=F/100   10
;-------------------------------------------------------------------------;
       call LC_F
;****   5100/510   ********************************
	movlw    0x02	 ; 
        subwf    REGA1,0 ;
 	btfsc STATUS,C
       goto   A_C       ;

	movlw    0xFE	 ; 
        subwf    REGA0,0 ;
 	btfsc STATUS,C
       goto   A_C        ;   5100  

       call Line1    ; 
	 call CLR_Line
       call Line2 
	 call CLR_Line

        call  Line1	;   1- 	
	    call  Text_ERROR

            goto    _Restart
A_C
	;clrf	StBy_H
	;clrf	StBy_L
;************   C pF = 25330/L=100/F^2*******************;
;***********************************************************************;
;--------    --------------------------;

	movf    REGA1,0	;
	movwf   REGB1	;
	movf    REGA0,0	;
	movwf   REGB0	;

    call  multiply	;.    REGA 
;---------   1000()------------------------------------;
	clrf	REGB3
	clrf	REGB2
  	movlw   0x03  	;   
	movwf   REGB1	
  	movlw   0xE8  	;   
	movwf   REGB0	;
    call  divide	;.    REGA

	movf    REGA1,0	;
	movwf   REGB1	;
	movf    REGA0,0	;
	movwf   REGB0	;

;------- 253 300 000----------------------

	movlw 0x0F	;   
	movwf REGA3	;

	movlw 0x19	;  
	movwf REGA2	;

	movlw 0x0D	;  
	movwf REGA1	;

	movlw 0x20	;  
	movwf REGA0	;
    call  divide	;.C pF = 25330/F^2 

;----------------------------------------------------------------------

	        btfsc  PORTA,Kn_Plus
	      goto   EN_CAL
	    call   Pause05sek
		btfsc  PORTA,Kn_Plus
	      goto   EN_CAL
       	    call  Line1
	    call   Text_Cal
       	    call  Line2
        call CLR_Line
;     EEPROM 2Ch.    
         movf  REGA1,0
            movwf   Temp 
 	 movlw      0x2C
	 call SAV_EEPR;     EEPROM W. TEMP. W

;     EEPROM 2Dh.     
         movf  REGA0,0
            movwf  Temp
 	 movlw      0x2D
	 call SAV_EEPR;     EEPROM W. TEMP. W
            call Pause05sek

	 call CLR_LCD ; 

EN_CAL
;--------------------------------------------------------------------------------------
            btfss  T5,0 ;   ר  \C\L\
	      goto   $+7
;   100.   
	clrf	REGB3
	clrf	REGB2
	clrf	REGB1
	movlw 0x64	;  100
	movwf REGB0	;
    call  multiply	;.    REGA 
;---------------------------------------------------------------------------------------
; ~ 650*10 Cx+C , 
; EEPROM     44h      REGB0.
	   movlw      0x2C
	call LO_EEPR
	   movwf      REGB1

;  EEPROM     45h      REGB0.

            movlw      0x2D           ;     EEPROM 45h
	call LO_EEPR
            movwf      REGB0          ;  45h   W   REGB0.

	clrf	REGB3
	clrf	REGB2
 ;----------- --------------------------------------------
       call Line1    ; 
	 call CLR_Line
       call Line2 
	 call CLR_Line
            call  Line1 	;   1- 
 ;	     	movlw "C"
 ;      	call  SendASCII 
 ;      	movlw "x"
 ;      	call  SendASCII 
       	movlw " "
       	call  SendASCII 
;--------------------------------------------------------------------
    call  subtract	;.    REGA, 
;******************   ******************************** 

;-----------   -----------------------
	btfss DSIGN,0
      goto   $+3
       	movlw "-"
       	call  SendASCII
;--------------------------------------------------------------------     
       call bin2dec     ;  REGA ---> DIGIT

;  ------------------------------------------ 
	movlw    0x01	   ; 
        subwf    DIGIT3,0  ;
 	btfsc STATUS,C
       goto  Cx_uF          ;   Lx- x.xx ukF

	movlw    0x01	   ; 
        subwf    DIGIT4,0  ;
 	btfsc STATUS,C
       goto  Cx_nF        ;   Lx- xx.xx nF

	movlw    0x01	   ; 
        subwf    DIGIT5,0  ;
 	btfsc STATUS,C
       goto   Cx_nF1       ;    Lx- x.xx nF

	movlw    0x01	   ; 
        subwf    DIGIT6,0  ;
 	btfsc STATUS,C
       goto   Cx_pF       ;   Lx- xxx.xx pF

	movlw    0x01	   ; 
        subwf    DIGIT7,0  ;
 	btfsc STATUS,C
       goto   Cx_pF1      ;   Lx- xx.xx pF 

       goto   Cx_pF2      ;   Lx- x.xx pF 
;-----------------------------------------------------------------------;
;           Cx- xxxx.xx pF                                ;
;-----------------------------------------------------------------------; 
Cx_pF
	movf  DIGIT6,0
       addlw "0"
       call  SendASCII   
Cx_pF1        movf  DIGIT7,0
       addlw "0"
       call  SendASCII 
Cx_pF2       movf  DIGIT8,0
       addlw "0"
       call  SendASCII

      movf  DIGIT9,0
       addlw "0"
       call  SendASCII 

        movlw ","
       call  SendASCII 

      movf  DIGIT10,0
       addlw "0"
       call  SendASCII
            call  Line2 	;   2- 
         movlw " "
       call  SendASCII 
       movlw "p"
       call  SendASCII
       movlw "F"
       call  SendASCII
	  
       goto    _Restart
;-----------------------------------------------------------------------;
;             Cx- xxx.x nF                               ;
;-----------------------------------------------------------------------; 

Cx_nF       movf  DIGIT4,0
       addlw "0"
       call  SendASCII
Cx_nF1       movf  DIGIT5,0
       addlw "0"
       call  SendASCII
       movf  DIGIT6,0
       addlw "0"
       call  SendASCII
       movlw "."
       call  SendASCII 
       movf  DIGIT7,0
       addlw "0"
       call  SendASCII
       movlw " "
       call  SendASCII
            call  Line2 	;   2- 
       movlw "n"
       call  SendASCII
       movlw "F"
       call  SendASCII

        goto    _Restart
;----------------------------------------------------------------------;
;-----------------------------------------------------------------------;
;               Cx- x.xx ukF                               ;
;-----------------------------------------------------------------------; 
Cx_uF
       
       movf  DIGIT3,0
       addlw "0"
       call  SendASCII
        movlw ","
       call  SendASCII 
       movf  DIGIT4,0
       addlw "0"
       call  SendASCII 
       movf  DIGIT5,0
       addlw "0"
       call  SendASCII
        movf  DIGIT6,0
          movlw " "
       call  SendASCII
            call  Line2 	;   2- 
       movlw 0x02  	; mu
       call  SendASCII
        movlw "F"
       call  SendASCII	  
       goto    _Restart

;*******************************************************************
;********** ***************************************
;*******************************************************************
F_metr
	clrf	StBy_H
	clrf	StBy_L
          	bsf  PORTB,7		; Power on.
;----------  F Metr-------------------------------------- 
       call Line1    ; 
	 call CLR_Line
       call Line2 
	 call CLR_Line

       call Line1
       movlw " "
       call  SendASCII
       movlw "F"
       call  SendASCII
	 call Text_Metr
       call Pause05sek 
 		btfss		PORTA,Kn_Set
	      goto $-1

;-------------------------------------------------------------------------;
            bsf    PORTC,3	;  ESR
            bcf    PORTC,2	;B  F
            bsf    PORTC,1	;  LC
;-------------------------------------------------------------------------;
F_start
;  StBy  4.
	 incfsz StBy_L,f	
	goto $+2		
        call  PWR_OFF	; Power off.

;----------  ESR metr---------------------------------------
          btfsc	PORTA,Kn_Set  
  	    goto LF1
       call Line1    ; 
	 call CLR_Line
       call Line2 
	 call CLR_Line

         call Line1 
       movlw " "
       call  SendASCII
       movlw "E"
       call  SendASCII
       movlw "S"
       call  SendASCII
       movlw "R"
       call  SendASCII
       movlw " "
       call  SendASCII
       movlw ">"
       call  SendASCII
;		call Text_Metr
       call Pause05sek 
            bsf    STATUS,RP0          ;  1
  		; 
		movlw	 b'10000100'	   ; , Vdd, Vss, AN0, AN1, AN3
		movwf	 ADCON1
            bcf    STATUS,RP0          ;  0
	        bcf   PCLATH,3
              goto START

LF1
;----------------------------------------------------------------------------------
;   RC0  T=1sek-    \REGA0 \REGA1 \REGA02 \REGA3\ 
 
       call  Count_FHz ;  
;----------------------------------------------------------------------------------       
       call Line1    ; 
	 call CLR_Line
       call Line2 
	 call CLR_Line
       call bin2dec     ;  REGA ---> DIGIT
 
;  ------------------------------------------------------------------ 

       call  Line1	;   1- 
	 movlw " "
       call  SendASCII
       movlw "F"
       call  SendASCII
       movlw "x"
       call  SendASCII
       movlw ">"
       call  SendASCII
       call  FreqHz     ;  
;----------------------------------------------------------------------------- 

 	 goto  F_start

;*****************************************************************************
;****************** F Metr****************************************
;-----------------------------------------------------------------------------;
;   RC0   Hz-    \REGA0\ REGA1\\REGA2\ REGA3\   ;
;-----------------------------------------------------------------------------;
Count_FHz 
                movlw   B'000000110'; 5-4 :    TMR1
       	    movwf   T1CON	      ;	 00=1:1       
            movlw       .229
            movwf       Temp4
            movlw       .4
            movwf       Temp
       clrf    REGA0	 
       clrf    REGA1
       clrf    REGA2	
       clrf    REGA3
       clrf    TMR1H    ;TMR1H-  16-  1
       clrf    TMR1L	;TMR1L-  16-  1
       bcf     PIR1,0	;     TMR1
       bsf     T1CON,0  ;0  TMR1ON:  TMR1    1=.

;====    1======================================================

del         movlw       .72
            movwf       Temp1
            movlw       .2
            movwf       Temp2
wrF         decfsz      Temp1, F
            goto        wrF
            decfsz      Temp2, F
            goto        wrF
;===========================================================================================
;    TMR1   REGA2
;    REGA2   REGA3
;===========================================================================================
            btfss      PIR1,0      ; TMR1   ?
            goto       Do          ; ,   -->     Do.
            incf       REGA2,F     ; ,  -->    REGA2
                                   ;       .
            btfsc      STATUS,Z
            incf       REGA3,F
  
            bcf        PIR1,0      ;    TMR1.
            nop 
            goto       CK          ;    CK.

Do          nop                    ;  NOP.
            nop                    ;  NOP.
            nop                    ;  NOP.
            nop                    ;  NOP.
            nop                    ;  NOP. 8CIKL
            nop                    ;  NOP. 9CIKL
  
CK          decfsz      Temp4,F 
            goto        del
            decfsz      Temp,F               
            goto        del
;====     1 .=========================================
          ;nop
          ;nop 
           nop

;====    1-================================================ 

       bcf     T1CON,0  ;0  TMR1ON:  TMR1    1=.

            btfss      PIR1,0      ; TMR1   ?
            goto       $+4         ; ,   -->   .
            incf       REGA2,F     ; ,  -->    REGA2
                                   ;       .
            btfsc      STATUS,Z
            incf       REGA3,F

       movf    TMR1H,0  ;TMR1H-  16-  1,0
       movwf   REGA1
       movf    TMR1L,0	;TMR1L-  16-  1,0
       movwf   REGA0	; c TMR1    REGA 

       return
;------------------------------------------------------------------------------------;
;     RC0 -    \REGA0\ REGA1\\REGA2\ REGA3\    ;
;------------------------------------------------------------------------------------;
;------------------------------------------------------------------------------------;
;      LCD 2*8                                                      ;
;------------------------------------------------------------------------------------;
FreqHz
;   ------------------------------------------ 
	movlw    0x01	   ; 
        subwf    DIGIT3,0  ;
 	btfsc STATUS,C
       goto  DIG8          ;   xx.xxx.xxx HZ

	movlw    0x01	   ; 
        subwf    DIGIT4,0  ;
 	btfsc STATUS,C
       goto  DIG7        ;   Lx-x.xxx.xxx HZ

	movlw    0x01	   ; 
        subwf    DIGIT5,0  ;
 	btfsc STATUS,C
       goto   DIG6       ;    Lx- xxx.xxx HZ

	movlw    0x01	   ; 
        subwf    DIGIT6,0  ;
 	btfsc STATUS,C
       goto   DIG5       ;   xx.xxx HZ
       goto   DIG4       ;   x.xxx HZ 


DIG8       movlw  0x082                 
       call   SendINS
	movf  DIGIT3,0
       addlw "0"
       call  SendASCII 
DIG7       movlw  0x083                 
       call   SendINS
	movf  DIGIT4,0
       addlw "0"
       call  SendASCII 
DIG6       movlw  0x084                 
       call   SendINS
       movlw " "
       call  SendASCII
	movf  DIGIT5,0
       addlw "0"
       call  SendASCII 

DIG5       movlw  0x086                
       call   SendINS
	movf  DIGIT6,0
       addlw "0"
       call  SendASCII 

DIG4         movlw  0x087                 
       call   SendINS
       movf  DIGIT7,0
       addlw "0"
       call  SendASCII 

       call Line2 
       movlw " "
       call  SendASCII
       movf  DIGIT8,0
       addlw "0"
       call  SendASCII
       movf  DIGIT9,0
       addlw "0"
       call  SendASCII 
      movf  DIGIT10,0
       addlw "0"
       call  SendASCII 
       movlw " "
       call  SendASCII
       movlw "H"
       call  SendASCII
       movlw "z"
       call  SendASCII	  
      return  
  
;**********************************************************************************;
;****************** LC Metr********************************************;
;**********************************************************************************;
;----------------------------------------------------------------------------------;
;   RC0 F=F/10 Hz-    \REGA0\ REGA1\\REGA2\ REGA3\   ;
;----------------------------------------------------------------------------------;
Count_LC        movlw   B'000100110'; 5-4 :    TMR1
       	    movwf   T1CON	      ;	 10=1:4      
            movlw       .200
            movwf       Temp4
            movlw       .2
            movwf       Temp
       clrf    REGA0	
       clrf    REGA1
       clrf    REGA2	 
       clrf    REGA3
       clrf    TMR1H    ;TMR1H-  16-  1
       clrf    TMR1L	;TMR1L-  16-  1
       bcf     PIR1,0	;     TMR1
       bsf     T1CON,0  ;0  TMR1ON:  TMR1    1=.

;====    0.4============================================;

delC        movlw       .30
            movwf       Temp1
            movlw       .2
            movwf       Temp2
wrC         decfsz      Temp1, F
            goto        wrC
            decfsz      Temp2, F
            goto        wrC
;===================================================================================;
;    TMR1   REGA2
;    REGA2   REGA3
;===================================================================================;
            btfss      PIR1,0      ; TMR1   ?
            goto       DoC         ; ,   -->     Do.
            incf       REGA2,F     ; ,  -->    REGA2
                                   ;       .
            btfsc      STATUS,Z
            incf       REGA3,F
  
            bcf        PIR1,0      ;    TMR1.
            goto       CKC         ;    CKC.

DoC         nop                    ;  NOP.
            nop                    ;  NOP.
            nop                    ;  NOP.
            nop                    ;  NOP.
            nop                    ;  NOP. 8CIKL
  
CKC         decfsz      Temp4,F 
            goto        delC
            decfsz      Temp,F               
            goto        delC
;  .......     0.4 ..............................

            movlw       .179
            movwf       Temp1
            decfsz      Temp1, F
	      goto   $-1
            nop
           nop
;====    0.4-========================================== 

       bcf     T1CON,0  ;0  TMR1ON:  TMR1    1=.

            btfss      PIR1,0      ; TMR1   ?
            goto       $+4         ; ,   -->     Do.
            incf       REGA2,F     ; ,  -->    REGA2
                                   ;       .
            btfsc      STATUS,Z
            incf       REGA3,F

       movf    TMR1H,0  ;TMR1H-  16-  1,0
       movwf   REGA1
       movf    TMR1L,0	;TMR1L-  16-  1,0
       movwf   REGA0	; c TMR1    REGA 

       return
;------------------------------------------------------------------------------------;
;     RC0 -    \REGA0\ REGA1\\REGA2\ REGA3\    ;
;------------------------------------------------------------------------------------;
;------------------------------------------------------------------------------------;
;   LC .   LC                                           ;
;    \REGA0\ REGA1\ F=F/100
;------------------------------------------------------------------------------------;
LC_F
           call  Count_LC    ;  LC 
;-----------------------------------------------------------------------
;****   7 936     10 ***********************
	movlw    0x01	 ; 
        subwf    REGA2,0 ;
 	btfsc STATUS,C
       goto   D_F        ;

	movlw    0x1F	 ; 
        subwf    REGA1,0 ;
 	btfsc STATUS,C
       goto   D_F        ;

  	movlw   0x01  	 ;   ר  \C\L\
	movwf   T5
               goto   D_F1
D_F
	clrf	T5
;---------     10-------------------------------;
	clrf	REGB3
	clrf	REGB2
	clrf	REGB1
  	movlw   0x0A  	;   10
	movwf   REGB0	;
    call  divide	;.    REGA 
D_F1
	clrf	REGB3
	clrf	REGB2
       return
 
;---------------------------------------------------------------------------------- 
;***************   Lx ************************************************
Cal_L
	 call Line1 
	call Text_Cal

;-------  ----------------------
;------- 253 300 000---------------------
	movlw 0x0F	;   
	movwf REGA3	;
	movlw 0x19	;  
	movwf REGA2	;
	movlw 0x0D	;  
	movwf REGA1	;
	movlw 0x20	;  
	movwf REGA0	;

;-------  F^2 ----------------------------
	clrf	REGB3
	clrf	REGB2
        movf  T1,0  ;  
     	movwf REGB1	;
 	movf  T0,0  ;  
	movwf REGB0	;

	call  divide	;.    REGA 

	clrf	REGB3
	clrf	REGB2
	clrf	REGB1
	movlw 0x0A	;  
	movwf REGB0
	call  divide
;-------------------   EEPROM --------------------------------------------------
;     EEPROM 24h.    
        movf  REGA1,0
            movwf   Temp 
 	 movlw      0x24
	call SAV_EEPR
;     EEPROM 25h.     
         movf  REGA0,0
            movwf  Temp
 	 movlw      0x25
	call SAV_EEPR

       call bin2dec     ;  REGA ---> DIGIT

        call Line2 
        movlw "C"
        call  SendASCII
        movlw "x"
        call  SendASCII
        movlw " "
        call  SendASCII

        movf  DIGIT8,0
        addlw "0"
        call  SendASCII
        movf  DIGIT9,0
        addlw "0"
        call  SendASCII 
        movf  DIGIT10,0
        addlw "0"
        call  SendASCII 

        movlw "p"
        call  SendASCII
        movlw "F"
        call  SendASCII

; 10000  +, 0
;  EEPROM  2-  
;     EEPROM 29h. 
        movf  T2,0
            movwf   Temp 
 	 movlw      0x29
	call SAV_EEPR
;     EEPROM 28h. 
         movf  T3,0
            movwf  Temp
 	 movlw      0x28
	call SAV_EEPR
            call Pause05sek 
       call CLR_LCD    ; 
          return
;***************  ***************************
;===============================================================================================
;      movlw 0x--h      W.  pF
;-----------------------------------------------------------------------------------------------
;      XXh      W.

LO_EEPR
            bsf        STATUS,RP1
            bcf        STATUS,RP0     ;    2.
            movwf      EEADR          ;  24h   W   EEAdr.
            bsf        STATUS,RP0       ;    3.
            bcf        EECON1,EEPGD     ; EEPROM .
	      bsf	     EECON1,RD        ; 
            bcf        STATUS,RP0       ;     2.
            movf       EEDATA,W    ;     EEPROM   25h   W.
	    bcf    STATUS,RP1
 	    bcf    STATUS,RP0	   ;   0
 		return
;-------------------   EEPROM --------------------------------------------------
;     EEPROM W. TEMP.
SAV_EEPR	    bsf        STATUS,RP1
            bsf        STATUS,RP0      ;    3.
	    btfsc        EECON1,WR
	    goto   $-1
	    bcf        STATUS,RP0      ;     2.
          movwf      EEADR           ;  00h   W   EEAdr.
	bcf    STATUS,RP1
 	bcf    STATUS,RP0	   ;   0
            movf       Temp,W 
	      bsf        STATUS,RP1      ;     2.
            movwf      EEDATA          ;     W   EEDATA
            bsf        STATUS,RP0      ;    3.
            bcf        EECON1,EEPGD    ;  EEPROM .
	      bsf        EECON1,WREN     ;  
            bcf        INTCON,GIE      ;   .            
            movlw      055h            ; 
            movwf      EECON2          ; 
            movlw      0AAh            ;  .
            movwf      EECON2          ; ----"----
            bsf        EECON1,WR       ;  
           ;bcf        INTCON,GIE      ;  . 
            bcf        EECON1,WREN     ;  
	bcf    STATUS,RP1
 	bcf    STATUS,RP0	   ;   0
 		return

;*************************************************************************
Text_Metr
       movlw " "
       call  SendASCII
       movlw "M"
       call  SendASCII
       movlw "e"
       call  SendASCII
       movlw "t"
       call  SendASCII
       movlw "r"
       call  SendASCII
       return 
Text_Lx
       movlw " "
       call  SendASCII
       movlw "L"
       call  SendASCII
       movlw "x"
       call  SendASCII
       movlw "-"
       call  SendASCII
       movlw "-"
       call  SendASCII
       movlw "-"
       call  SendASCII
       return 
Text_ERROR
       movlw " "
       call  SendASCII
       movlw "C"
       call  SendASCII
       movlw "x"
       call  SendASCII
       movlw " "
       call  SendASCII
       movlw "E"
       call  SendASCII
       movlw "R"
       call  SendASCII
       movlw "R"
       call  SendASCII
;       movlw "O"
;       call  SendASCII
;       movlw "R"
;       call  SendASCII

       return 
Text_Cal
        movlw " "
       call  SendASCII      
        movlw "C"
        call  SendASCII
        movlw "a"
        call  SendASCII
        movlw "l"
        call  SendASCII
        movlw "i"
        call  SendASCII
        movlw "b"
        call  SendASCII
        movlw "r"
        call  SendASCII
        movlw "."
        call  SendASCII

;        movlw "a"
;        call  SendASCII
;        movlw "t"
;        call  SendASCII
;        movlw "i"
;        call  SendASCII
;        movlw "o"
;        call  SendASCII
;        movlw "n"
;        call  SendASCII

	return
Text_save
        movlw " "
        call  SendASCII
        movlw "S"
        call  SendASCII
        movlw "a"
        call  SendASCII
        movlw "v"
        call  SendASCII
;        movlw "e"
;        call  SendASCII
        movlw " "
        call  SendASCII
        movlw "E"
        call  SendASCII
        movlw "E"
        call  SendASCII
;        movlw "P"
;        call  SendASCII
;        movlw "R"
;        call  SendASCII
;        movlw "O"
;        call  SendASCII
;        movlw "M"
;        call  SendASCII
	return
;----------------------------------------------------------------------;
;                        time delay routines                           ;
;----------------------------------------------------------------------;
 
Delay_200_us1	

;delay = 2'998 machine cycles; ~400 
       	movlw       .151
            movwf       Temp1
            movlw       .3
            movwf       Temp2
DL          decfsz      Temp1, F
            goto        DL
            decfsz      Temp2, F
            goto        DL
		return   
Pause1sek
    ;delay = 999'996 machine cycles
            movlw       .172
            movwf       Temp1
            movlw       .19
            movwf       Temp2
            movlw       .6
            movwf       Temp3
L2          decfsz      Temp1, F
            goto        L2
            decfsz      Temp2, F
            goto        L2
            decfsz      Temp3, F
            goto        L2
            nop
          	return 
Pause05sek 
;delay = 499'996 machine cycles
            movlw       .84
            movwf       Temp1
            movlw       .138
            movwf       Temp2
            movlw       .3
            movwf       Temp3
L3          decfsz      Temp1, F
            goto        L3
            decfsz      Temp2, F
            goto        L3
            decfsz      Temp3, F
            goto        L3
            nop
          	return

CLR_REGB	;  REGB
	clrf	REGB0	
	clrf	REGB1
	clrf	REGB2
	clrf	REGB3
          	return
CLRF_REG_MAT
	      CLRF REGA0				;lsb
		CLRF REGA1
		CLRF REGA2
		CLRF REGA3				;msb

		CLRF REGB0				;lsb
		CLRF REGB1
		CLRF REGB2
		CLRF REGB3				;msb

		CLRF REGC0				;lsb
		CLRF REGC1
		CLRF REGC2
		CLRF REGC3	
 		return
;********************************************************************************
;**************   ***************************************
;*** 32 BIT SIGNED SUTRACT ***
;REGA - REGB -> REGA
;Return carry set if overflow

subtract
	call	negateb		;Negate REGB
	skpnc
	return			;Overflow

;*** 32 BIT SIGNED ADD ***
;REGA + REGB -> REGA
;Return carry set if overflow

add	movf	REGA3,w		;Compare signs
	xorwf	REGB3,w
	movwf	MTEMP

	call	addba		;Add REGB to REGA

	clrc			;Check signs
	movf	REGB3,w		;If signs are same
	xorwf	REGA3,w		;so must result sign
	btfss	MTEMP,7		;else overflow
	addlw	0x80
	return

;*** 32 BIT SIGNED MULTIPLY ***
;REGA * REGB -> REGA
;Return carry set if overflow

multiply
	clrf	MTEMP		;Reset sign flag
	call	absa		;Make REGA positive
	skpc
	call	absb		;Make REGB positive
	skpnc
	return			;Overflow

	call	movac		;Move REGA to REGC
	call	clra		;Clear product

	movlw	D'31'		;Loop counter
	movwf	MCOUNT

muloop	call	slac		;Shift left product and multiplicand
	
	rlf	REGC3,w		;Test MSB of multiplicand
	skpnc			;If multiplicand bit is a 1 then
	call	addba		;add multiplier to product

	skpc			;Check for overflow
	rlf	REGA3,w
	skpnc
	return

	decfsz	MCOUNT,f	;Next
	goto	muloop

	btfsc	MTEMP,0		;Check result sign
	call	negatea		;Negative
	return

;*** 32 BIT SIGNED DIVIDE ***
;REGA / REGB -> REGA
;Remainder in REGC
;Return carry set if overflow or division by zero

divide	clrf	MTEMP		;Reset sign flag
	movf	REGB0,w		;Trap division by zero
	iorwf	REGB1,w
	iorwf	REGB2,w
	iorwf	REGB3,w
	sublw	0
	skpc
	call	absa		;Make dividend (REGA) positive
	skpc
	call	absb		;Make divisor (REGB) positive
	skpnc
	return			;Overflow

	clrf	REGC0		;Clear remainder
	clrf	REGC1
	clrf	REGC2
	clrf	REGC3
	call	slac		;Purge sign bit

	movlw	D'31'		;Loop counter
	movwf	MCOUNT

dvloop	call	slac		;Shift dividend (REGA) msb into remainder (REGC)

	movf	REGB3,w		;Test if remainder (REGC) >= divisor (REGB)
	subwf	REGC3,w
	skpz
	goto	dtstgt
	movf	REGB2,w
	subwf	REGC2,w
	skpz
	goto	dtstgt
	movf	REGB1,w
	subwf	REGC1,w
	skpz
	goto	dtstgt
	movf	REGB0,w
	subwf	REGC0,w
dtstgt	skpc			;Carry set if remainder >= divisor
	goto	dremlt

	movf	REGB0,w		;Subtract divisor (REGB) from remainder (REGC)
	subwf	REGC0,f
	movf	REGB1,w
	skpc
	incfsz	REGB1,w
	subwf	REGC1,f
	movf	REGB2,w
	skpc
	incfsz	REGB2,w
	subwf	REGC2,f
	movf	REGB3,w
	skpc
	incfsz	REGB3,w
	subwf	REGC3,f
	clrc
	bsf	REGA0,0		;Set quotient bit

dremlt	decfsz	MCOUNT,f	;Next
	goto	dvloop

	btfsc	MTEMP,0		;Check result sign
	call	negatea		;Negative
	return

;*** ROUND RESULT OF DIVISION TO NEAREST INTEGER ***
round	clrf	MTEMP		;Reset sign flag
	call	absa		;Make positive
	clrc
	call	slc		;Multiply remainder by 2
	movf	REGB3,w		;Test if remainder (REGC) >= divisor (REGB)
	subwf	REGC3,w
	skpz
	goto	rtstgt
	movf	REGB2,w
	subwf	REGC2,w
	skpz
	goto	dtstgt
	movf	REGB1,w
	subwf	REGC1,w
	skpz
	goto	rtstgt
	movf	REGB0,w
	subwf	REGC0,w
rtstgt	skpc			;Carry set if remainder >= divisor
	goto	rremlt
	incfsz	REGA0,f		;Add 1 to quotient
	goto	rremlt
	incfsz	REGA1,f
	goto	rremlt
	incfsz	REGA2,f
	goto	rremlt
	incf	REGA3,f
	skpnz
	return			;Overflow,return carry set
rremlt	btfsc	MTEMP,0		;Restore sign
	call	negatea
	return


;*** 32 BIT SQUARE ROOT ***
;sqrt(REGA) -> REGA
;Return carry set if negative

sqrt	rlf	REGA3,w		;Trap negative values
	skpnc
	return

	call	movac		;Move REGA to REGC
	call	clrba		;Clear remainder (REGB) and root (REGA)

	movlw	D'16'		;Loop counter
	movwf	MCOUNT

sqloop	rlf	REGC0,f		;Shift two msb's
	rlf	REGC1,f		;into remainder
	rlf	REGC2,f
	rlf	REGC3,f
	rlf	REGB0,f
	rlf	REGB1,f
	rlf	REGB2,f
	rlf	REGC0,f
	rlf	REGC1,f
	rlf	REGC2,f
	rlf	REGC3,f
	rlf	REGB0,f
	rlf	REGB1,f
	rlf	REGB2,f

	setc			;Add 1 to root
	rlf	REGA0,f		;Align root
	rlf	REGA1,f
	rlf	REGA2,f

	movf	REGA2,w		;Test if remdr (REGB) >= root (REGA)
	subwf	REGB2,w
	skpz
	goto	ststgt
	movf	REGA1,w
	subwf	REGB1,w
	skpz
	goto	ststgt
	movf	REGA0,w
	subwf	REGB0,w
ststgt	skpc			;Carry set if remdr >= root
	goto	sremlt

	movf	REGA0,w		;Subtract root (REGA) from remdr (REGB)
	subwf	REGB0,f
	movf	REGA1,w
	skpc
	incfsz	REGA1,w
	subwf	REGB1,f
	movf	REGA2,w
	skpc
	incfsz	REGA2,w
	subwf	REGB2,f
	bsf	REGA0,1		;Set current root bit

sremlt	bcf	REGA0,0		;Clear test bit
	decfsz	MCOUNT,f	;Next
	goto	sqloop

	clrc
	rrf	REGA2,f		;Adjust root alignment
	rrf	REGA1,f
	rrf	REGA0,f
	return


;*** 32 BIT SIGNED BINARY TO DECIMAL ***
;REGA -> DIGITS 1 (MSD) TO 10 (LSD) & DSIGN
;DSIGN = 0 if REGA is positive, 1 if negative
;Return carry set if overflow
;Uses FSR register

bin2dec	clrf	MTEMP		;Reset sign flag
	call	absa		;Make REGA positive
	skpnc
	return			;Overflow

	call	clrdig		;Clear all digits

	movlw	D'32'		;Loop counter
	movwf	MCOUNT

b2dloop	rlf	REGA0,f		;Shift msb into carry
	rlf	REGA1,f
	rlf	REGA2,f
	rlf	REGA3,f

	movlw	DIGIT10
	movwf	FSR		;Pointer to digits
	movlw	D'10'		;10 digits to do
	movwf	DCOUNT

adjlp	rlf	INDF,f		;Shift digit and carry 1 bit left
	movlw	D'10'
	subwf	INDF,w		;Check and adjust for decimal overflow
	skpnc
	movwf	INDF

	decf	FSR,f		;Next digit
	decfsz	DCOUNT,f
	goto	adjlp

	decfsz	MCOUNT,f	;Next bit
	goto	b2dloop

	btfsc	MTEMP,0		;Check sign
	bsf	DSIGN,0		;Negative
	clrc
	return


;*** 32 BIT SIGNED DECIMAL TO BINARY ***
; *** 32     () ***
;Decimal DIGIT1 thro DIGIT(X) & DSIGN -> REGA
;Set DSIGN = 0 for positive, DSIGN = 1 for negative values
;Most significant digit in DIGIT1
;Enter this routine with digit count in w register
;Return carry set if overflow
;Uses FSR register

dec2bin	movwf	MTEMP		;Save digit count

	movlw	D'32'		;Outer bit loop counter
	movwf	MCOUNT

d2blp1	movlw	DIGIT1-1	;Set up pointer to MSD
	movwf	FSR
	movf	MTEMP,w		;Inner digit loop counter
	movwf	DCOUNT

	movlw	D'10'
	clrc			;Bring in '0' bit into MSD

d2blp2	incf	FSR,f
	skpnc
	addwf	INDF,f		;Add 10 if '1' bit from prev digit
	rrf	INDF,f		;Shift out LSB of digit

	decfsz	DCOUNT,f	;Next L.S. Digit
	goto	d2blp2

	rrf	REGA3,f		;Shift in carry from digits
	rrf	REGA2,f
	rrf	REGA1,f
	rrf	REGA0,f

	decfsz	MCOUNT,f	;Next bit
	goto	d2blp1

	movf	INDF,w		;Check for overflow
	addlw	0xFF
	skpc
	rlf	REGA3,w
	skpnc
	return

	btfsc	DSIGN,0		;Check result sign
	call	negatea		;Negative
	return


;UTILITY ROUTINES


;Add REGB to REGA (Unsigned)
;Used by add, multiply,

addba	movf	REGB0,w		;Add lo byte
	addwf	REGA0,f

	movf	REGB1,w		;Add mid-lo byte
	skpnc			;No carry_in, so just add
	incfsz	REGB1,w		;Add carry_in to REGB
	addwf	REGA1,f		;Add and propagate carry_out

	movf	REGB2,w		;Add mid-hi byte
	skpnc
	incfsz	REGB2,w
	addwf	REGA2,f

	movf	REGB3,w		;Add hi byte
	skpnc
	incfsz	REGB3,w
	addwf	REGA3,f
	return


;Move REGA to REGC
;Used by multiply, sqrt

movac	movf	REGA0,w
	movwf	REGC0
	movf	REGA1,w
	movwf	REGC1
	movf	REGA2,w
	movwf	REGC2
	movf	REGA3,w
	movwf	REGC3
	return


;Clear REGB and REGA
;Used by sqrt

clrba	clrf	REGB0
	clrf	REGB1
	clrf	REGB2
	clrf	REGB3

;Clear REGA
;Used by multiply, sqrt

clra	clrf	REGA0
	clrf	REGA1
	clrf	REGA2
	clrf	REGA3
	return


;Check sign of REGA and convert negative to positive
;Used by multiply, divide, bin2dec, round

absa	rlf	REGA3,w
	skpc
	return			;Positive

;Negate REGA
;Used by absa, multiply, divide, bin2dec, dec2bin, round

negatea	movf	REGA3,w		;Save sign in w
	andlw	0x80

	comf	REGA0,f		;2's complement
	comf	REGA1,f
	comf	REGA2,f
	comf	REGA3,f
	incfsz	REGA0,f
	goto	nega1
	incfsz	REGA1,f
	goto	nega1
	incfsz	REGA2,f
	goto	nega1
	incf	REGA3,f
nega1
	incf	MTEMP,f		;flip sign flag
	addwf	REGA3,w		;Return carry set if -2147483648
	return


;Check sign of REGB and convert negative to positive
;Used by multiply, divide

absb	rlf	REGB3,w
	skpc
	return			;Positive

;Negate REGB
;Used by absb, subtract, multiply, divide

negateb	movf	REGB3,w		;Save sign in w
	andlw	0x80

	comf	REGB0,f		;2's complement
	comf	REGB1,f
	comf	REGB2,f
	comf	REGB3,f
	incfsz	REGB0,f
	goto	negb1
	incfsz	REGB1,f
	goto	negb1
	incfsz	REGB2,f
	goto	negb1
	incf	REGB3,f
negb1
	incf	MTEMP,f		;flip sign flag
	addwf	REGB3,w		;Return carry set if -2147483648
	return


;Shift left REGA and REGC
;Used by multiply, divide, round

slac	rlf	REGA0,f
	rlf	REGA1,f
	rlf	REGA2,f
	rlf	REGA3,f
slc	rlf	REGC0,f
	rlf	REGC1,f
	rlf	REGC2,f
	rlf	REGC3,f
	return

;Set all digits to 0
;Used by bin2dec

clrdig	clrf	DSIGN
	clrf	DIGIT1
	clrf	DIGIT2
	clrf	DIGIT3
	clrf	DIGIT4
	clrf	DIGIT5
	clrf	DIGIT6
	clrf	DIGIT7
	clrf	DIGIT8
	clrf	DIGIT9
	clrf	DIGIT10
	return
;**********************************************************************************
;  
	INCLUDE "LCD.inc"

       END
